%% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   DSeg software is currently under active development.We welcome comments
%   and contributions to the documentation and code of DSeg to help  us 
%   improve the implementation.
%
%	Related information can be found in the paper :
% 
%   DSeg: A dynamic segmentation program to extract backbone patterns for
%   filamentous bacteria and hyphae structures, March 2018
% 
%   Hanqing Zhang,Niklas Soderholm, Linda Sandblad, Krister Wiklund,
%   Magnus Andersson*
%   * Corresponding author
% 
%  Contact information:  Hanqing Zhang :  hanqing.zhang@umu.se
%                        Magnus Andersson : magnus.andersson@umu.se
% 
%  GNU GENERAL PUBLIC LICENSE Version 3, 29 June 2007
% 
%  Copyright (C) 2007 Free Software Foundation, Inc. <http://fsf.org/>
%  Everyone is permitted to copy and distribute verbatim copies
%  of this license document, but changing it is not allowed.
%%  Default
function varargout = DSeg(varargin)
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @DSeg_OpeningFcn, ...
    'gui_OutputFcn',  @DSeg_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% 1. Init
function DSeg_OpeningFcn(hObject, eventdata, handles, varargin)
% ʼ
handles.output = hObject;
%% ·ʼ
warning('off','all');
OpeningFcn_setPaths();
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% ȫֱ
set(handles.output, 'UserData',[]);
% ͣ
SystemParameters.stop = false;
% ֹͣ
SystemParameters.pause = false;
set(handles.output, 'UserData',SystemParameters);
%% ɹʵ
handles.DSegOperator=DSeg_IMPLEMENTATION();
handles=OpeningFcn_setGUI(handles);
% Update handles structure
guidata(hObject, handles);
% 1.1 Set Path
function OpeningFcn_setPaths()
if (~isdeployed)
    CurrentFile = mfilename('fullpath');
    [ProgramFolder, ~] = fileparts(CurrentFile);
    Functions_FilesName='Methods';
    Functions_FolderName=strcat(ProgramFolder,'\',Functions_FilesName);
    if ~exist(Functions_FolderName,'dir')
        mkdir(Functions_FolderName);
    end
    addpath(Functions_FilesName);
    Interfaces_FilesName='Methods\Interfaces';
    Interfaces_FolderName=strcat(ProgramFolder,'\',Interfaces_FilesName);
    if ~exist(Interfaces_FolderName,'dir')
        mkdir(Interfaces_FolderName);
    end
    addpath(Interfaces_FilesName);
    Func_FilesName='Methods\Functions';
    Acc_FolderName=strcat(ProgramFolder,'\',Func_FilesName);
    if ~exist(Acc_FolderName,'dir')
        mkdir(Acc_FolderName);
    end
    addpath(Func_FilesName);
end
function handles=OpeningFcn_setGUI(handles)
%% 
% ǿֵ
set(handles.Slider_Theshold,'value',handles.DSegOperator.Config.DetectionConfig.EdgeThresh);
set(handles.Slider_Theshold,'min',0);
set(handles.Slider_Theshold,'max',1);
% ӴС
Max_KernelSize=10;
set(handles.Slider_KernelSize,'value',handles.DSegOperator.Config.PreProcessConfig.KernelSize);
set(handles.Slider_KernelSize,'min',0);
set(handles.Slider_KernelSize,'max',Max_KernelSize);
% ˹ǿ
Max_GaussSize=10;
set(handles.Slider_GaussianKernelSize,'value',handles.DSegOperator.Config.PreProcessConfig.Gaussian.KernelSize);
set(handles.Slider_GaussianKernelSize,'min',0);
set(handles.Slider_GaussianKernelSize,'max',Max_GaussSize);
% ˹ǿ()
Max_GaussSize=30;
set(handles.slider_BackgroundSubGaussianKernel,'value',handles.DSegOperator.Config.PreProcessConfig.Backgroundsub.Gaussian.KernelSize);
set(handles.slider_BackgroundSubGaussianKernel,'min',1);
set(handles.slider_BackgroundSubGaussianKernel,'max',Max_GaussSize);
% Offset
set(handles.Slider_AutoThreshOffSet,'value',handles.DSegOperator.Config.DetectionConfig.AutoThreshOffset);
set(handles.Slider_AutoThreshOffSet,'min',-1);
set(handles.Slider_AutoThreshOffSet,'max',1);
% Threshold value
set(handles.Slider_Theshold,'value',0.5);
set(handles.Slider_Theshold,'min',0);
set(handles.Slider_Theshold,'max',1);
% Set system parameters
set(handles.TEXT_System_PixelSpacing,'String',num2str(handles.DSegOperator.Config.System.PixelSpacing*1e9,'%10.3f'));
set(handles.TEXT_System_TimeInterval,'String',num2str(handles.DSegOperator.Config.System.TimeInterval,'%10.1f'));
% Set other parameters
convf2=handles.DSegOperator.Config.System.PixelSpacing*1e6;

set(handles.TEXT_SelectObjectMinSize,'String',num2str(handles.DSegOperator.Config.DetectionConfig.MinSize*convf2,'%10.3f'));
set(handles.TEXT_SelectObjectMaxSize,'String',num2str(handles.DSegOperator.Config.DetectionConfig.MaxSize*convf2,'%10.3f'));
set(handles.TEXT_SelectEndFrames,'String',num2str(handles.DSegOperator.Config.ProcessEndFrame,'%10.0f'));
set(handles.TEXT_System_TimeInterval,'String',num2str(handles.DSegOperator.Config.System.TimeInterval,'%10.1f'));

set(handles.TEXT_CurrentBackgroundMaskRatio,'String',num2str(handles.DSegOperator.Config.DetectionConfig.CurrentBackgroundMaskRatio,'%10.1f'));
set(handles.TEXT_BackgroundThreholdLevel,'String',num2str(handles.DSegOperator.Config.DetectionConfig.BackgroundThreholdLevel,'%10.1f'));
set(handles.TEXT_BackgroundThreholdWeight,'String',num2str(handles.DSegOperator.Config.DetectionConfig.NoBranchWeightMagnitude,'%10.0f'));
%% ť
handles=GUI_DisableButtons(handles);
%% GUI
handles=UpdateCustomizedGUIs(handles);
%% ʾ
% ǰ
set(handles.TEXT_SelectNumofFrames,'String',num2str(handles.DSegOperator.Config.ProcessFrames));
function handles=UpdateCustomizedGUIs(handles)
%% Customized GUIs
handles.Axes_ProcessBar=axes( ...
    'Parent', handles.Panel_Plot,...
    'Unit','Centimeter',...
    'Color','w',...
    'XColor','w','YColor','w', ...
    'OuterPosition',[0.05 1.05 23 0.8],...
    'Position',[0.05 1.05 23 0.8],...
    'Xlimmode','auto',...
    'Ylimmode','auto',...
    'XLim', [0 1], ...
    'YLim', [0 1], ...
    'Box', 'on', ...
    'ytick', [], ...
    'xtick', [] );
text(0.5, 0.5,'-- Welcome to DSeg software --', ...
    'HorizontalAlignment', 'center', ...
    'Parent',handles.Axes_ProcessBar,...
    'FontUnits', 'Normalized', ...
    'FontSize', 0.7 );

handles.SegmentationGroup = uitabgroup('Parent', handles.Panel_Segmentation,'Unit','Centimeter','Position',[0.5 0.15 7.7 2],'OuterPosition', [0.5 0.15 7.7 2]);
handles.SegmentationGroup_Tab_AutoDetect = uitab('Parent', handles.SegmentationGroup, 'Title', 'Auto Detection','ButtonDownFcn',@(hObject,eventdata)DSeg('SegmentationGroup_Tab_AutoDetect_Callback',hObject,eventdata,guidata(hObject)));
handles.SegmentationGroup_Tab_ManualRefine = uitab('Parent', handles.SegmentationGroup, 'Title', 'Manual Refinement','ButtonDownFcn',@(hObject,eventdata)DSeg('SegmentationGroup_Tab_ManualRefine_Callback',hObject,eventdata,guidata(hObject)));
% Auto Detect
set(handles.Button_SegmentationAll,'Parent',handles.SegmentationGroup_Tab_AutoDetect,'Unit','Centimeter','Position',[0.05 0.2 3.5 0.8],'OuterPosition',[0.05 0.2 3.5 0.8]);
set(handles.Button_Pause,'Parent',handles.SegmentationGroup_Tab_AutoDetect,'Unit','Centimeter','Position',[3.5 0.2 2 0.8],'OuterPosition',[3.5 0.2 2 0.8]);
set(handles.Button_Stop,'Parent',handles.SegmentationGroup_Tab_AutoDetect,'Unit','Centimeter','Position',[5.5 0.2 2 0.8],'OuterPosition',[5.5 0.2 2 0.8]);
% Manual Detect
set(handles.Button_InitMask,'Parent',handles.SegmentationGroup_Tab_ManualRefine,'Unit','Centimeter','Position',[0.1 0.2 3 0.8],'OuterPosition',[0.1 0.2 3 0.8]);
set(handles.Button_Forward,'Parent',handles.SegmentationGroup_Tab_ManualRefine,'Unit','Centimeter','Position',[3.1 0.2 3 0.8],'OuterPosition',[3.1 0.2 3 0.8]);
function varargout = DSeg_OutputFcn(hObject, eventdata, handles)
varargout{1} = handles.output;
%% 2. ǣգ
% 2.1 Load video/image
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Buttom_LOADVIDEO_Callback(hObject, eventdata, handles)
%% 
choice = questdlg('Delete all result files and load new data?', ...
    'Loading... ', ...
    'Yes','No','No');
switch choice
    case 'Yes'
        
    case 'No'
        return;
end

handles=ClearALLSegmentationResults(handles);
handles=clear_ROI(handles);
%%
[filename, pathname] = uigetfile( ...
    {'*.gif;*.jpeg;*.jpg;*.png;*.tiff;*.bmp;*.ico;*.ras;*.avi;*.mpg;*.mpeg;*.wmv;*.mp4;*.mj2;*.mov',...
    'Load Media Files (*.gif,*.jpeg,*.jpg,*.png,*.tiff,*.bmp,*.ico,*.ras,*.avi,*.mpg,*.mpeg,*.wmv,*.mp4,*.mj2,*.mov)';
    '*.*',  'All Files (*.*)'}, ...
    'Select a media file');
if isequal(filename,0)||isequal(pathname,0)
    set(handles.Edit_VideoAddress,'String','Please select a video file...');
    handles=GUI_DisableButtons(handles);
    guidata(hObject, handles);
    UpdateInfo(handles,'- DSeg software - Biophysics & Biophotonics group, Department of Physics,Umea University');
    return
else
    Outputs.fullpath=[pathname filename];
    [Outputs.path, Outputs.name,Outputs.extension] = fileparts(Outputs.fullpath);
    if sum(strcmp(Outputs.extension,{'.avi', '.mpg', '.mpeg', '.wmv', '.mp4','.mov','.mj2'}))>=1
        try % read video file
            AVIobj=VideoReader(Outputs.fullpath);
            set(handles.Edit_VideoAddress,'String',Outputs.fullpath);
        catch
            set(handles.Edit_VideoAddress,'String','Cannot load the data, please select a video/image file...');
            handles=GUI_DisableButtons(handles);
            guidata(hObject, handles);
            return
        end
        handles=LOADVIDEO_Init(handles,AVIobj);
    elseif sum(strcmp(Outputs.extension,{'.gif', '.jpeg','.jpg', '.png', '.tiff', '.bmp','.ras'}))>=1
        try % read image file
            handles=LOADImage_Init(handles,Outputs.fullpath);
        catch
            set(handles.Edit_VideoAddress,'String','Cannot load the data, please select a video/image file...');
            handles=GUI_DisableButtons(handles);
            guidata(hObject, handles);
            return
        end
    else
        set(handles.Edit_VideoAddress,'String','Cannot load the data, please select a video/image file...');
        handles=GUI_DisableButtons(handles);
        return
    end
end
% Update Buttoms
handles=UpdateButtonsLoadVideo(handles);
% Update handles structure
handles=updateProcessEndFrame(handles);
UpdateInfo(handles,'Data loaded.');
guidata(hObject, handles);
function handles=GUI_DisableButtons(handles)
% 
set(handles.Button_SegmentationAll,'Enable','off');
set(handles.Button_Pause,'Enable','off');
set(handles.Button_Stop,'Enable','off');
set(handles.Button_Forward,'Enable','off');
set(handles.Button_InitMask,'Enable','off');

% 
set(handles.Slider_FrameNumber,'Enable','off');
set(handles.TEXT_SelectEndFrames,'Enable','off');
% Preporcessing
% ROI
set(handles.checkbox_ROI_Active,'Enable','off');
set(handles.Button_ReferenceRegionClear,'Enable','off');
% Resize
set(handles.checkbox_Resize,'Enable','off');
set(handles.TEXT_ResizeNumber,'Enable','off');
% Invert intensity
set(handles.checkbox_InvertIntensity,'Enable','off');
% Thresholding
set(handles.Button_AdaptiveThresholding,'Enable','off');
set(handles.Button_GlobalThresholding,'Enable','off');
set(handles.Slider_AutoThreshOffSet,'Enable','off');
set(handles.TEXT_AutoThreshOffSetValue,'Enable','off');
set(handles.checkbox_AutoThreshold,'Enable','off');
set(handles.Slider_Theshold,'Enable','off');
set(handles.TEXT_ThreshValue,'Enable','off');
% Filter
set(handles.checkbox_MedianFilter,'Enable','off');
set(handles.Slider_KernelSize,'Enable','off');

set(handles.checkbox_GaussianFilter,'Enable','off');
set(handles.Slider_GaussianKernelSize,'Enable','off');

set(handles.checkbox_AnisotropicFilter,'Enable','off');
set(handles.TEXT_Aniso_iteration,'Enable','off');
set(handles.TEXT_Aniso_step,'Enable','off');
set(handles.TEXT_Aniso_kappa,'Enable','off');
% Background subtraction
set(handles.checkbox_BackgroundSub,'Enable','off');
set(handles.popupmenu_BackgroundSubtraction,'Enable','off');
set(handles.slider_BackgroundSubGaussianKernel,'Enable','off');
% Intensity Rescaling
set(handles.checkbox_Rescaling,'Enable','off');

% Detection
set(handles.check_ShowMask,'Enable','off');
set(handles.checkbox_showSkeletonMask,'Enable','off');
set(handles.checkbox_ShowSkeletonMaskNoBranch,'Enable','off');
set(handles.StaticObjectParameterSettings,'Enable','off');
set(handles.TEXT_SelectObjectMinSize,'Enable','off');
set(handles.TEXT_SelectObjectMaxSize,'Enable','off');

% Single cell
set(handles.Button_SelectCells,'Enable','off');
set(handles.Button_CheckDetection,'Enable','off');

set(handles.Buttom_AutoSelection,'Enable','off');
set(handles.Button_SelectFromImage,'Enable','off');
% LevelSet
set(handles.TEXT_LevelSet_Istrength,'Enable','off');
set(handles.TEXT_LevelSet_Gstrength,'Enable','off');
set(handles.TEXT_LevelSetBranchArea,'Enable','off');
set(handles.TEXT_LevelSetBranchSplit,'Enable','off');
%Background
set(handles.TEXT_CurrentBackgroundMaskRatio,'Enable','off');
set(handles.TEXT_BackgroundThreholdLevel,'Enable','off');
set(handles.TEXT_BackgroundThreholdWeight,'Enable','off');

set(handles.TEXT_SelectNumofFrames,'Enable','off');
set(handles.Text_ShowFrameNum,'Enable','off');
% Detection info
set(handles.Button_SaveResults,'Enable','off');
set(handles.Botton_AddobjecttoList,'Enable','off');
set(handles.Botton_DeleteobjectfromList,'Enable','off');
set(handles.Botton_ClearList,'Enable','off');
% Detection manual refinement
set(handles.pushbutton_SelectObject,'Enable','off');
set(handles.pushbutton_disconnect,'Enable','off');
set(handles.pushbutton_connect,'Enable','off');
% Analysis 
set(handles.Button_AnalysisRemove,'Enable','off');
set(handles.Button_AnalysisClear,'Enable','off');
set(handles.Button_AnalysisPresentResults,'Enable','off');
set(handles.Button_Analyze,'Enable','off');

function handles=UpdateButtonsLoadVideo(handles)
%% Parameters updates
% Clear Selection
handles.DSegOperator.Config.PreviousFrame=[];
handles.DSegOperator.Config.DetectionConfig.Method.SEED=[];
handles.DSegOperator.Config.DetectionConfig.Method.LEVELSET_MASK=0;
handles.DSegOperator.Config.Results.Data=[];
% Assign resize factor
ObjectSize=size(handles.DSegOperator.Config.Frame);
if(sum(ObjectSize>handles.DSegOperator.Config.ImageOptimalSizeLimit)>0)
    Longside=mean(ObjectSize(max(ObjectSize)==ObjectSize));
    handles.DSegOperator.Config.PreProcessConfig.Resize.On=1;
    handles.DSegOperator.Config.PreProcessConfig.Resize.Num=handles.DSegOperator.Config.ImageOptimalSizeLimit/Longside;
else
    handles.DSegOperator.Config.PreProcessConfig.Resize.On=0;
    handles.DSegOperator.Config.PreProcessConfig.Resize.Num=1;
end
% Assign default Theshold
handles=UpdatePreProcessNDetectionNoSeedPoint(handles);
handles=UpdateFrameNum(handles);
handles=update_ROI_Info(handles);
% Update Slider
set(handles.Slider_FrameNumber,'value',1);
set(handles.Slider_FrameNumber,'min',1);
set(handles.Slider_FrameNumber,'max',round(handles.DSegOperator.Config.AVIobj.Duration*handles.DSegOperator.Config.AVIobj.FrameRate));
set(handles.Slider_Theshold,'value',handles.DSegOperator.Config.DetectionConfig.EdgeThresh);

%% GUI updates
%% 
%set(handles.Button_SegmentationAll,'Enable','on');
set(handles.TEXT_SelectNumofFrames,'Enable','on');
set(handles.Text_ShowFrameNum,'Enable','on');
%set(handles.Button_Forward,'Enable','on');
%% 
set(handles.Slider_FrameNumber,'Enable','on');
set(handles.TEXT_SelectEndFrames,'Enable','on');
%% Preporcessing
% ROI
set(handles.Button_ReferenceRegionClear,'Enable','on');
set(handles.checkbox_ROI_Active,'Enable','on');
if(handles.DSegOperator.Config.PreProcessConfig.ROI_ON==1)
    set(handles.checkbox_ROI_Active,'Value',1);
else
    set(handles.checkbox_ROI_Active,'Value',0);
end

% Resize
set(handles.checkbox_Resize,'Enable','on');
if(handles.DSegOperator.Config.PreProcessConfig.Resize.On==1)
    set(handles.TEXT_ResizeNumber,'Enable','on');
    set(handles.checkbox_Resize,'Value',1);
    set(handles.TEXT_ResizeNumber,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Resize.Num,'%10.1f'));
else
    set(handles.checkbox_Resize,'Value',0);
    set(handles.TEXT_ResizeNumber,'Enable','off');
    set(handles.TEXT_ResizeNumber,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Resize.Num,'%10.1f'));
end

% תǿ
set(handles.checkbox_InvertIntensity,'Enable','on');
if(handles.DSegOperator.Config.PreProcessConfig.InverseIntensity==1)
    set(handles.checkbox_InvertIntensity,'Value',1);
else
    set(handles.checkbox_InvertIntensity,'Value',0);
end

% Filter
set(handles.checkbox_MedianFilter,'Enable','on');
if(handles.DSegOperator.Config.PreProcessConfig.Medfilt==1)
    set(handles.Slider_KernelSize,'Enable','on');
    set(handles.TEXT_MedianKernelSizeValue,'Enable','on');
else
    set(handles.Slider_KernelSize,'Enable','off');
    set(handles.TEXT_MedianKernelSizeValue,'Enable','off');
end
set(handles.TEXT_MedianKernelSizeValue,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.KernelSize,'%10.0f'));

set(handles.checkbox_GaussianFilter,'Enable','on');
if(handles.DSegOperator.Config.PreProcessConfig.Gaussian.On==1)
    set(handles.Slider_GaussianKernelSize,'Enable','on');
    set(handles.TEXT_GaussianKernelSizeValue,'Enable','on');
    set(handles.TEXT_GaussianKernelVarianceValue,'Enable','on');
else
    set(handles.Slider_GaussianKernelSize,'Enable','off');
    set(handles.TEXT_GaussianKernelSizeValue,'Enable','off');
    set(handles.TEXT_GaussianKernelVarianceValue,'Enable','off');
end
set(handles.TEXT_GaussianKernelSizeValue,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Gaussian.KernelSize,'%10.0f'));
set(handles.TEXT_GaussianKernelVarianceValue,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Gaussian.Variance,'%10.2f'));

set(handles.checkbox_AnisotropicFilter,'Enable','on');
if(handles.DSegOperator.Config.PreProcessConfig.Aniso==1)
    set(handles.TEXT_Aniso_iteration,'Enable','on');
    set(handles.TEXT_Aniso_iteration,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Aniso_iteration,'%d'));
    set(handles.TEXT_Aniso_step,'Enable','on');
    set(handles.TEXT_Aniso_step,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Aniso_step,'%10.2f'));
    set(handles.TEXT_Aniso_kappa,'Enable','on');
    set(handles.TEXT_Aniso_kappa,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Aniso_kappa,'%10.2f'));
end

% 
set(handles.checkbox_BackgroundSub,'Enable','on');
if(handles.DSegOperator.Config.PreProcessConfig.Backgroundsubtraction==1)
    set(handles.checkbox_BackgroundSub,'Value',1);
    set(handles.popupmenu_BackgroundSubtraction,'Enable','on');
    switch handles.DSegOperator.Config.PreProcessConfig.BackgroundsubtractionMethod
        case 'Gaussian'
            set(handles.popupmenu_BackgroundSubtraction,'Value',1);
            set(handles.slider_BackgroundSubGaussianKernel,'Enable','on');
        case 'Gaussian Norm'
            set(handles.popupmenu_BackgroundSubtraction,'Value',2);
            set(handles.slider_BackgroundSubGaussianKernel,'Enable','on');
    end
else
    set(handles.checkbox_BackgroundSub,'Value',0);
    set(handles.popupmenu_BackgroundSubtraction,'Enable','off');
end
% Intensity Rescaling
set(handles.checkbox_Rescaling,'Enable','on');
if(handles.DSegOperator.Config.PreProcessConfig.IntensityRescaling==1)
    set(handles.checkbox_Rescaling,'Value',1);
else
    set(handles.checkbox_Rescaling,'Value',0);
end
%% Detection
% Thresholding
set(handles.TEXT_SelectObjectMinSize,'Enable','on');
set(handles.TEXT_SelectObjectMaxSize,'Enable','on');

set(handles.Button_AdaptiveThresholding,'Enable','on');
set(handles.Button_GlobalThresholding,'Enable','on');
if(handles.DSegOperator.Config.DetectionConfig.AdaptiveThresh==1)
    set(handles.Button_AdaptiveThresholding,'Value',1);
    set(handles.Slider_Theshold,'Enable','off');
    set(handles.TEXT_ThreshValue,'Enable','off');
else
    set(handles.Button_GlobalThresholding,'Value',1);
    set(handles.Slider_Theshold,'Enable','on');
    set(handles.TEXT_ThreshValue,'Enable','on');
end

% Զֵ
set(handles.checkbox_AutoThreshold,'Enable','on');
if(handles.DSegOperator.Config.DetectionConfig.AutoThresh==1)
    set(handles.checkbox_AutoThreshold,'Value',1);
else
    set(handles.checkbox_AutoThreshold,'Value',0);
end

set(handles.Buttom_AutoSelection,'Enable','on');
set(handles.Button_SelectFromImage,'Enable','on');
if(handles.DSegOperator.Config.DetectionConfig.AutoSelect==1)
    set(handles.Buttom_AutoSelection,'Value',1);
    set(handles.Button_SelectFromImage,'Value',0);
else
    set(handles.Buttom_AutoSelection,'Value',0);
    set(handles.Button_SelectFromImage,'Value',1);
end

set(handles.Slider_AutoThreshOffSet,'Enable','on');
set(handles.TEXT_AutoThreshOffSetValue,'Enable','on');

set(handles.Slider_Theshold,'Value',handles.DSegOperator.Config.DetectionConfig.EdgeThresh);
set(handles.Slider_AutoThreshOffSet,'Value',handles.DSegOperator.Config.DetectionConfig.AutoThreshOffset);
set(handles.TEXT_ThreshValue,'String',num2str(handles.DSegOperator.Config.DetectionConfig.EdgeThresh,'%10.3f'));
set(handles.TEXT_AutoThreshOffSetValue,'String',num2str(handles.DSegOperator.Config.DetectionConfig.AutoThreshOffset,'%10.3f'));

% Local Level set
if(handles.DSegOperator.Config.DetectionConfig.SingleCell==1)
    % % Single Cell
    set(handles.Button_SelectCells,'Enable','on');
    handles.DSegOperator.Config.DetectionConfig.Method.Name='SingleCellDetection';
    if(handles.DSegOperator.Config.DetectionConfig.Method.LEVELSET_ON==1)
        % ʹlevel set
        set(handles.TEXT_LevelSet_Istrength,'Enable','on');
        set(handles.TEXT_LevelSet_Gstrength,'Enable','on');
        set(handles.TEXT_LevelSetBranchArea,'Enable','on');
        set(handles.TEXT_LevelSetBranchSplit,'Enable','on');
        
        set(handles.TEXT_LevelSet_Istrength,'String',num2str(handles.DSegOperator.Config.DetectionConfig.LEVELSET.Istrength,'%10.2f'));
        set(handles.TEXT_LevelSet_Gstrength,'String',num2str(handles.DSegOperator.Config.DetectionConfig.LEVELSET.Gstrength,'%10.1f'));
        set(handles.TEXT_LevelSetBranchArea,'String',num2str(handles.DSegOperator.Config.DetectionConfig.LEVELSET.MaxMergeSize,'%10.0f'));
        set(handles.TEXT_LevelSetBranchSplit,'String',num2str(handles.DSegOperator.Config.DetectionConfig.LEVELSET.MinSplitSize,'%10.0f'));
    else
        set(handles.TEXT_LevelSet_Istrength,'Enable','off');
        set(handles.TEXT_LevelSet_Gstrength,'Enable','off');
        set(handles.TEXT_LevelSetBranchArea,'Enable','off');
        set(handles.TEXT_LevelSetBranchSplit,'Enable','off');
    end
else
    set(handles.Button_SelectCells,'Enable','off');
    handles.DSegOperator.Config.DetectionConfig.Method.Name='Default';
end
% Background
set(handles.TEXT_CurrentBackgroundMaskRatio,'Enable','on');
set(handles.TEXT_BackgroundThreholdLevel,'Enable','on');
set(handles.TEXT_BackgroundThreholdWeight,'Enable','on');

% ʾ,mask
set(handles.check_ShowMask,'Enable','on');
if(handles.DSegOperator.Config.DetectionConfig.ShowMask==1)
    set(handles.check_ShowMask,'Value',1);
else
    set(handles.check_ShowMask,'Value',0);
end
if(~isempty(handles.DSegOperator.Config.DetectionConfig.Method.SEED))
    set(handles.checkbox_showSkeletonMask,'Enable','on');
    set(handles.StaticObjectParameterSettings,'Enable','on');
    set(handles.Button_InitMask,'Enable','on');
    
    if(handles.DSegOperator.Config.DetectionConfig.ShowSkeletonMask==1)
        set(handles.checkbox_showSkeletonMask,'Value',1);
        set(handles.checkbox_ShowSkeletonMaskNoBranch,'Enable','on');
    else
        set(handles.checkbox_showSkeletonMask,'Value',0);
        set(handles.checkbox_ShowSkeletonMaskNoBranch,'Enable','off');
    end
    if(handles.DSegOperator.Config.DetectionConfig.ShowSkeletonNoBranchMask==1)
        set(handles.checkbox_ShowSkeletonMaskNoBranch,'Value',1);
    else
        set(handles.checkbox_ShowSkeletonMaskNoBranch,'Value',0);
    end
else
    handles.DSegOperator.Config.DetectionConfig.ShowSkeletonMask=0;
    set(handles.checkbox_showSkeletonMask,'Value',0);
    set(handles.checkbox_showSkeletonMask,'Enable','off');
    set(handles.checkbox_ShowSkeletonMaskNoBranch,'Enable','off');
    set(handles.StaticObjectParameterSettings,'Enable','off');
end

% Detection info
set(handles.Botton_AddobjecttoList,'Enable','on');
set(handles.Botton_DeleteobjectfromList,'Enable','on');
set(handles.Botton_ClearList,'Enable','on');
function handles=ClearALLSegmentationResults(handles)
% Reset all results
handles.DSegOperator.ClearDetection;
% Reset configurations
handles.DSegOperator.Config.DetectionConfig.ValidMask=0;
handles.DSegOperator.Config.DetectionConfig.PreviousMask=[];
handles.DSegOperator.Config.DetectionConfig.CurrentMask=[];
handles.DSegOperator.Config.DetectionConfig.SkeletonMask=[];
handles.DSegOperator.Config.DetectionConfig.ShowSkeletonMask=0;
%handles.DSegOperator.Config.DetectionConfig.ShowSkeletonNoBranchMask=0;
handles.DSegOperator.Config.DetectionConfig.Method.SEED=[];
handles.DSegOperator.Config.DetectionConfig.Method.LEVELSET_MASK=0;
% Update detection list
handles=updateSelectedObjectList(handles);
% Init current Id for Segmentation
handles.DSegOperator.Config.DetectionConfig.Current.ApplyID=0;
% Clear all files in the folder
handles=ClearALLAnalysis(handles);

function handles=ClearALLAnalysis(handles)
Path=handles.DSegOperator.Config.OutputConfig.PathDetection;
filename=strcat(Path,'*.mat');
files = dir(filename);
if(~isempty(files))
    for i=1:length(files)
        delete(strcat(files(i).folder,'\',files(i).name));
    end
end
handles.DSegOperator.Results=struct('Name', [],'Data',[]);

function handles=LOADVIDEO_Init(handles,AVIobj)
% Init Aviobj
handles.DSegOperator.Config.AVIobj=AVIobj;
handles.DSegOperator.Config.AVIobj.CurrentTime = 0;
% Update Frame
handles.DSegOperator.Config.Frame=readFrame(handles.DSegOperator.Config.AVIobj);
function handles=LOADImage_Init(handles,Address)
AVIobj.Name=[];
AVIobj.TotalFrames=1;
info = imfinfo(Address);
AVIobj.FrameNumber=1;
AVIobj.FrameRate=1;
AVIobj.Duration=0;

handles.DSegOperator.Config.Frame=imread(Address);

AVIobj.Width=size(handles.DSegOperator.Config.Frame,1);
AVIobj.Height=size(handles.DSegOperator.Config.Frame,2);
AVIobj.ColorFormat= info.ColorType;
% Init Aviobj
handles.DSegOperator.Config.AVIobj=AVIobj;
handles.DSegOperator.Config.AVIobj.CurrentTime = 0;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2.2 Segmentation 
function SegmentationGroup_Tab_AutoDetect_Callback(hObject, ~, handles)
guidata(hObject, handles);
function SegmentationGroup_Tab_ManualRefine_Callback(hObject, ~, handles)
guidata(hObject, handles);
function Button_SegmentationAll_Callback(hObject, eventdata, handles)
set(handles.Button_Stop,'Enable','on');
set(handles.Button_Pause,'Enable','on');
set(handles.Button_SegmentationAll,'Enable','off');
guidata(hObject,handles);  %Update the GUI data
Endprocess=0;
UpdateInfo(handles,'Processing...');
if(~isempty(handles.DSegOperator.Detection))
    % init Current id
    handles.DSegOperator.Config.DetectionConfig.Current.ApplyID=0;
    for i_detect=1:length(handles.DSegOperator.Detection)
        handles.DSegOperator.Config.DetectionConfig.Current.ID=i_detect;
        set(handles.TEXT_CurrentObjectID,'String',num2str(handles.DSegOperator.Detection(handles.DSegOperator.Config.DetectionConfig.Current.ID).Id));
        % Check if completed
        while(handles.DSegOperator.Detection(handles.DSegOperator.Config.DetectionConfig.Current.ID).Completed~=1)
            % Ƿμ
            if(handles.DSegOperator.Config.DetectionConfig.Current.ID~=handles.DSegOperator.Config.DetectionConfig.Current.ApplyID)
                handles.DSegOperator.Config.DetectionConfig.Current.ApplyID=handles.DSegOperator.Config.DetectionConfig.Current.ID;
                handles.DSegOperator.Config.DetectionConfig.Current.Frame=handles.DSegOperator.Detection(handles.DSegOperator.Config.DetectionConfig.Current.ID).CurrentFrame;
                handles.DSegOperator.Config.DetectionConfig.Current.Masks=[];
                %handles.DSegOperator.Config.DetectionConfig.SkeletonNoBranchMask=
                % Get Seed image mask from detection (dont change ROI or resize)
                handles=updateDetectionMask(handles);
            else
                % Get the latest seed image mask
                if(isempty(handles.DSegOperator.Config.DetectionConfig.Method.SEED))
                    handles=updateDetectionMask(handles);
                end
            end
            % Check frame number
            startingframe=handles.DSegOperator.Config.FrameNum;
            if(startingframe~=handles.DSegOperator.Detection(handles.DSegOperator.Config.DetectionConfig.Current.ID).CurrentFrame)
                startingframe=handles.DSegOperator.Detection(handles.DSegOperator.Config.DetectionConfig.Current.ID).CurrentFrame;
            end
            % Get next frame
            handles.DSegOperator.Config.AVIobj.CurrentTime = double(startingframe-1)/handles.DSegOperator.Config.AVIobj.FrameRate;
            if(~isempty(handles.DSegOperator.Config.AVIobj.Name))
                handles.DSegOperator.Config.Frame=readFrame(handles.DSegOperator.Config.AVIobj);
            end
            handles=UpdateFrameNum(handles);
            
            % Init seed
            handles=initSelectionParameters(handles);
            
            % Assign seed
            handles.DSegOperator.Config.DetectionConfig.Method.SEED=handles.DSegOperator.Detection(handles.DSegOperator.Config.DetectionConfig.Current.ID).SeedPoints;
            % Segmentation
            handles.DSegOperator.Preprocess(handles.DSegOperator.Config.Frame);
            handles.DSegOperator.Detect(handles.DSegOperator.Image,0);
            
            % Update detection properties
            if(handles.DSegOperator.Config.DetectionConfig.ValidMask==1)
                % Analysis of the results
                handles.DSegOperator.Analyze(handles.DSegOperator.Config.FrameNum);
                handles=UpdateAnalysisResult(handles);
                % Update results
                handles.DSegOperator.SetDetection(handles.DSegOperator.Config.DetectionConfig.Current.ID,...
                    'PixelIDs',find(handles.DSegOperator.Config.DetectionConfig.SkeletonNoBranchMask==1));
                handles.DSegOperator.SetDetection(handles.DSegOperator.Config.DetectionConfig.Current.ID,...
                    'CurrentFrame',handles.DSegOperator.Detection(handles.DSegOperator.Config.DetectionConfig.Current.ID).CurrentFrame+1);
                updateSelectedObjectList(handles);
            else
                break;
            end 
            % Update slide and image
            set(handles.Slider_FrameNumber,'Value',handles.DSegOperator.Config.FrameNum);
            Present_ImageTemplate(handles);
            
            if(startingframe>=handles.DSegOperator.Detection(handles.DSegOperator.Config.DetectionConfig.Current.ID).EndFrame)
                handles.DSegOperator.SetDetection(handles.DSegOperator.Config.DetectionConfig.Current.ID,...
                    'Completed',1);
                WriteShape(handles);
                break;
            end
            % Interrupts
            userData = get(handles.output, 'UserData');
            if userData.stop == true
                Endprocess=1;
                userData.stop = false; % Reset for next time
                set(handles.figure_CGTracking,'UserData',userData);
                break;
            end
            if userData.pause == true
                while(userData.pause == true)
                    pause(0.01);
                    userData = get(handles.output, 'UserData');
                end
            end
        end
        if(Endprocess==1)
            break;
        end
    end
end
% Write Results
set(handles.Button_Stop,'Enable','off');
set(handles.Button_Pause,'Enable','off');
set(handles.Button_SegmentationAll,'Enable','on');
UpdateInfo(handles,'Completed');
handles=UpdateAfterSegmentation(handles,'on');
guidata(hObject,handles);  %Update the GUI data
% 2.3.1 ͣ,ֹͣ
function Button_Pause_Callback(hObject, eventdata, handles)
% hObject    handle to Button_Pause (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
userData = get(handles.output, 'UserData');
if(userData.pause==true)
    userData.pause = false;
    set(hObject,'String','Pause');
    set(handles.Button_Stop,'Enable','on');
else
    userData.pause = true;
    set(hObject,'String','Continue');
    set(handles.Button_Stop,'Enable','off');
end
set(handles.output,'UserData',userData);
%
guidata(hObject, handles);
function Button_Stop_Callback(hObject, eventdata, handles)
% hObject    handle to Button_Stop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
userData = get(handles.output, 'UserData');
userData.stop = true;
set(handles.output,'UserData',userData);
%
set(hObject,'Enable','off');
guidata(hObject, handles);
% 2.3.2 
function Button_Forward_Callback(hObject, eventdata, handles)
% Update seed points using previous detection
handles.DSegOperator.Config.DetectionConfig.Selection=0;
UpdateInfo(handles,'Processing...');
set(hObject,'Enable','off');
% Update Frame
tic;
handles=getCurrentSelectionID(handles);
ExeTime=toc;
Message=strcat('Execution time:',num2str(ExeTime,'%10.4f'),' s.');
UpdateInfo(handles,Message);
handles=UpdateAfterSegmentation(handles,'on');
% Update gui
set(hObject,'Enable','on');
guidata(hObject, handles);
function handles=UpdateAfterSegmentation(handles,option)
% Analysis 
set(handles.Button_AnalysisRemove,'Enable',option);
set(handles.Button_AnalysisClear,'Enable',option);
set(handles.Button_AnalysisPresentResults,'Enable',option);
set(handles.Button_Analyze,'Enable',option);
set(handles.Button_SaveResults,'Enable',option);
function handles=getCurrentSelectionID(handles)
if(~isempty(handles.DSegOperator.Detection))
    Detection_current=handles.DSegOperator.Detection(handles.DSegOperator.Config.DetectionConfig.Current.ID);
    % Check if completed
    if(Detection_current.Completed==1)
        set(handles.listbox_AnalysisDataList,'BackgroundColor',[0 1 0]);
        return;
    else
        set(handles.listbox_AnalysisDataList,'BackgroundColor',[1 1 1]);
    end
    % Ƿμ
    if(handles.DSegOperator.Config.DetectionConfig.Current.ID~=handles.DSegOperator.Config.DetectionConfig.Current.ApplyID)
        handles.DSegOperator.Config.DetectionConfig.Current.ApplyID=handles.DSegOperator.Config.DetectionConfig.Current.ID;
        handles.DSegOperator.Config.DetectionConfig.Current.Frame=Detection_current.CurrentFrame;
        handles.DSegOperator.Config.DetectionConfig.Current.Masks=[];
        
        % Get Seed image mask from detection (dont change ROI or resize)
        handles=updateDetectionMask(handles);
    else
        % Get the latest seed image mask
        %handles=updateDetectionMask(handles);
        if(isempty(handles.DSegOperator.Config.DetectionConfig.Method.SEED))
            handles=updateDetectionMask(handles);
        end
    end
    % Check frame number
    startingframe=handles.DSegOperator.Config.FrameNum;
    if(startingframe~=Detection_current.CurrentFrame)
        startingframe=Detection_current.CurrentFrame;
    end
    % Get next frame
    handles.DSegOperator.Config.AVIobj.CurrentTime = double(startingframe-1)/handles.DSegOperator.Config.AVIobj.FrameRate;
    if(~isempty(handles.DSegOperator.Config.AVIobj.Name))
        handles.DSegOperator.Config.Frame=readFrame(handles.DSegOperator.Config.AVIobj);
    end
    handles=UpdateFrameNum(handles);
    
    % Init seed
    handles=initSelectionParameters(handles);
    
    % Assign seed
    handles.DSegOperator.Config.DetectionConfig.Method.SEED=Detection_current.SeedPoints;
    % Segmentation
    handles.DSegOperator.Preprocess(handles.DSegOperator.Config.Frame);
    handles.DSegOperator.Detect(handles.DSegOperator.Image,0);
    
    % Update detection properties
    if(handles.DSegOperator.Config.DetectionConfig.ValidMask==1)
        % Analysis and save data to file
        handles.DSegOperator.Analyze(handles.DSegOperator.Config.FrameNum);
        handles=UpdateAnalysisResult(handles); 
        % Update results
        handles.DSegOperator.SetDetection(handles.DSegOperator.Config.DetectionConfig.Current.ID,...
            'PixelIDs',find(handles.DSegOperator.Config.DetectionConfig.SkeletonNoBranchMask==1));
        handles.DSegOperator.SetDetection(handles.DSegOperator.Config.DetectionConfig.Current.ID,...
            'CurrentFrame',Detection_current.CurrentFrame+1);
        updateSelectedObjectList(handles);
    end
    
    % Update slide and image
    set(handles.Slider_FrameNumber,'Value',handles.DSegOperator.Config.FrameNum);
    Present_ImageTemplate(handles);
    
    if(startingframe>=Detection_current.EndFrame)
        handles.DSegOperator.SetDetection(handles.DSegOperator.Config.DetectionConfig.Current.ID,...
            'Completed',1);
        WriteShape(handles);
        return;
    end
    
end
function handles=updateDetectionMask(handles)
id=handles.DSegOperator.Config.DetectionConfig.Current.ID;
Skeleton_object=zeros(size(handles.DSegOperator.Image));
Skeleton_object(handles.DSegOperator.Detection(id).PixelIDs)=1;
handles.DSegOperator.Config.DetectionConfig.SkeletonNoBranchWeight=Skeleton_object;
handles.DSegOperator.Config.DetectionConfig.SkeletonNoBranchMask=Skeleton_object;
handles.DSegOperator.Config.DetectionConfig.SkeletonMask=Skeleton_object;
handles.DSegOperator.Config.DetectionConfig.CurrentMask=bwmorph(Skeleton_object,'dilate',max(1,round((handles.DSegOperator.Detection(id).Width-1)/2)));
handles.DSegOperator.Config.DetectionConfig.PreviousBackgroundMask=[];
handles.DSegOperator.Config.DetectionConfig.CurrentBackgroundMask=(handles.DSegOperator.DetectionMask-Skeleton_object)>0;
handles.DSegOperator.Config.DetectionConfig.AdaptiveK=ones(size(Skeleton_object))*handles.DSegOperator.Config.DetectionConfig.CurrentBackgroundMaskRatio;
function handles=updateApplyID(handles)
handles.DSegOperator.Config.DetectionConfig.Current.ApplyID=0;
% Other functions
function Edit_VideoAddress_Callback(hObject, eventdata, handles)
function Edit_VideoAddress_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function List_TrackingCells_Callback(hObject, eventdata, handles)
function List_TrackingCells_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function handles=UpdatePreProcessNDetectionNoSeedPoint(handles)
handles.DSegOperator.Config.DetectionConfig.Method.SEED=[];
handles.DSegOperator.Preprocess(handles.DSegOperator.Config.Frame);
handles.DSegOperator.Detect(handles.DSegOperator.Image,1);
Present_ImageTemplate(handles);
function handles=UpdateDetectionMaskNoSeedPoint(handles)
set(handles.check_ShowMask,'Value',1);
handles.DSegOperator.Config.DetectionConfig.ShowMask=1;
handles.DSegOperator.Config.DetectionConfig.Method.SEED=[];
handles.DSegOperator.Detect(handles.DSegOperator.Image,1);
Present_ImageTemplate(handles);
%
function handles=UpdatePreprocessing(handles)
handles.DSegOperator.Preprocess(handles.DSegOperator.Config.Frame);
Present_ImageTemplate(handles);
function handles=UpdatePreprocessingWithoutPresenting(handles)
handles.DSegOperator.Preprocess(handles.DSegOperator.Config.Frame);
% ͼ
function Present_ImageTemplate(handles)
f_handle=figure(handles.figure_CGTracking);
set(f_handle,'CurrentAxes',handles.MainAxes_FrameDisplay)

RGB_Present=zeros([size(handles.DSegOperator.Image) 3]);
listID=0;
for i_check=1:length(handles.DSegOperator.Detection)
    if(handles.DSegOperator.Config.DetectionConfig.Current.ID==i_check)
        listID=i_check; break;
    end
end
if(listID==0)
    if(handles.DSegOperator.Config.DetectionConfig.ValidMask==0)
        if(handles.DSegOperator.Config.DetectionConfig.ShowMask==0)
            ImagePresent=handles.DSegOperator.Image;
        else
            ImagePresent=imfuse(handles.DSegOperator.DetectionMask,handles.DSegOperator.Image,'blend','Scaling','joint');
        end
    else
        RGB_Present(:,:,2)=handles.DSegOperator.Config.DetectionConfig.CurrentMask;
        ImagePresent=imfuse(RGB_Present,handles.DSegOperator.Image,'blend','Scaling','joint');
    end
    imshow(ImagePresent);
    return;
end
if(handles.DSegOperator.Config.DetectionConfig.ShowMask==0)
    ImagePresent=handles.DSegOperator.Image;
else
    if(isempty(handles.DSegOperator.Config.DetectionConfig.SkeletonMask))
        if(handles.DSegOperator.Config.DetectionConfig.ShowMask==0)
            ImagePresent=handles.DSegOperator.Image;
        else
            ImagePresent=imfuse(handles.DSegOperator.DetectionMask,handles.DSegOperator.Image,'blend','Scaling','joint');
        end
    else
        if(handles.DSegOperator.Config.DetectionConfig.ShowSkeletonNoBranchMask==1)
            RGB_Present(:,:,2)=bwmorph(handles.DSegOperator.Config.DetectionConfig.SkeletonNoBranchMask,'dilate',max(1,round((handles.DSegOperator.Detection(listID).Width-1)/2)));
            ImagePresent=imfuse(RGB_Present,handles.DSegOperator.Image,'blend','Scaling','joint');
        else
            RGB_Present(:,:,2)=handles.DSegOperator.Config.DetectionConfig.CurrentMask;
            ImagePresent=imfuse(RGB_Present,handles.DSegOperator.Image,'blend','Scaling','joint');
        end
    end
end
imshow(ImagePresent);
function handles=UpdateFrameNum(handles)
handles.DSegOperator.Config.FrameNum=max(1,round(handles.DSegOperator.Config.AVIobj.FrameRate*handles.DSegOperator.Config.AVIobj.CurrentTime));
set(handles.Text_ShowFrameNum,'String',num2str(handles.DSegOperator.Config.FrameNum));
function handles=UpdateTempMask(handles)
if(isempty(handles.DSegOperator.Config.DetectionConfig.Method.SEED))
    handles.DSegOperator.Config.DetectionConfig.ShowSkeletonMask=0;
    set(handles.checkbox_showSkeletonMask,'Value',0);
    set(handles.checkbox_showSkeletonMask,'Enable','off');
    set(handles.checkbox_ShowSkeletonMaskNoBranch,'Enable','off');
    set(handles.StaticObjectParameterSettings,'Enable','off');
else
    set(handles.Button_InitMask,'Enable','on');
    set(handles.checkbox_showSkeletonMask,'Enable','on');
    set(handles.checkbox_ShowSkeletonMaskNoBranch,'Enable','on');
    set(handles.StaticObjectParameterSettings,'Enable','on');
    if(handles.DSegOperator.Config.DetectionConfig.ShowSkeletonMask==1)
        set(handles.checkbox_showSkeletonMask,'Value',1);
    else
        set(handles.checkbox_showSkeletonMask,'Value',0);
    end
    if(handles.DSegOperator.Config.DetectionConfig.ShowSkeletonNoBranchMask==1)
        set(handles.checkbox_ShowSkeletonMaskNoBranch,'Value',1);
    else
        set(handles.checkbox_ShowSkeletonMaskNoBranch,'Value',0);
    end
end
% Frame Slider
function Slider_FrameNumber_Callback(hObject, eventdata, handles)
Num=get(hObject,'Value');

% Update Frame
set(hObject,'Enable','off');
if(Num>0)
    handles.DSegOperator.Config.AVIobj.CurrentTime = double(round(Num)-1)/handles.DSegOperator.Config.AVIobj.FrameRate;
    set(hObject,'Value',round(Num));
end
if(~isempty(handles.DSegOperator.Config.AVIobj.Name))
    handles.DSegOperator.Config.Frame=readFrame(handles.DSegOperator.Config.AVIobj);
end

% Update Frame
handles=UpdatePreProcessNDetectionNoSeedPoint(handles);
handles=UpdateFrameNum(handles);
set(hObject,'Enable','on');
handles=updateProcessEndFrame(handles);
guidata(hObject, handles);
function Slider_FrameNumber_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Slider_FrameNumber (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end
function Text_ShowFrameNum_Callback(hObject, eventdata, handles)
% hObject    handle to Text_ShowFrameNum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
Numstring=get(hObject,'String');
if(isempty(Numstring))
    set(hObject,'String',num2str(handles.DSegOperator.Config.FrameNum));
    set(handles.Slider_FrameNumber,'Value',handles.DSegOperator.Config.FrameNum);
    guidata(hObject, handles);
    return
end
[PFrameNumber, status] = str2num(Numstring);
if(status==0)
    set(hObject,'String',num2str(handles.DSegOperator.Config.FrameNum));
    set(handles.Slider_FrameNumber,'Value',handles.DSegOperator.Config.FrameNum);
    guidata(hObject, handles);
    return
end
PFrameNumber=round(PFrameNumber);
if(PFrameNumber>=1 && PFrameNumber<=round(handles.DSegOperator.Config.AVIobj.FrameRate*(handles.DSegOperator.Config.AVIobj.Duration)))
    handles.DSegOperator.Config.FrameNum=PFrameNumber;
elseif(PFrameNumber==0)
    handles.DSegOperator.Config.FrameNum=1;
else
    set(hObject,'String',num2str(handles.DSegOperator.Config.ProcessFrames));
    set(handles.Slider_FrameNumber,'Value',handles.DSegOperator.Config.FrameNum);
    return
end
set(handles.Slider_FrameNumber,'Value',handles.DSegOperator.Config.FrameNum);

handles.DSegOperator.Config.AVIobj.CurrentTime = double(handles.DSegOperator.Config.FrameNum-1)/handles.DSegOperator.Config.AVIobj.FrameRate;
if(~isempty(handles.DSegOperator.Config.AVIobj.Name))
        handles.DSegOperator.Config.Frame=readFrame(handles.DSegOperator.Config.AVIobj);
end
% Update Frame
handles=UpdatePreProcessNDetectionNoSeedPoint(handles);
handles=UpdateFrameNum(handles);
handles=updateProcessEndFrame(handles);
guidata(hObject, handles);
function Text_ShowFrameNum_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
%% Preprocessing
% ROI
function Button_ReferenceRegionClear_Callback(hObject, eventdata, handles)
handles.DSegOperator.Config.PreProcessConfig.ROI_ON=0;
handles=clear_ROI(handles);
handles=update_ROI_Info(handles);
% Update process and Show image
handles=UpdatePreProcessNDetectionNoSeedPoint(handles);
guidata(hObject, handles);
function checkbox_ROI_Active_Callback(hObject, eventdata, handles)
CheckValue=get(hObject,'Value');
if(CheckValue==1)
    handles.DSegOperator.Config.PreProcessConfig.ROI_ON=1;
    handles=set_ROI(handles);
else
    handles.DSegOperator.Config.PreProcessConfig.ROI_ON=0;
    handles=clear_ROI(handles);
end
handles=UpdatePreProcessNDetectionNoSeedPoint(handles);
handles=update_ROI_Info(handles);
guidata(hObject, handles);
function handles=set_ROI(handles)
UpdateInfoColor(handles,'Drag or move blue lines and double clicking inside the squared region.',[0 1 0]);
figure(handles.figure_CGTracking)
axes(handles.MainAxes_FrameDisplay);
axes1_handle=gca;
imshow(handles.DSegOperator.Config.Frame);
% Update Preprocessing Region-of-interest
ROI=selectROI(handles.DSegOperator.Config.Frame,axes1_handle);
handles.DSegOperator.Config.PreProcessConfig.ROI=ROI;
% !!! Clear Results
handles=ClearALLSegmentationResults(handles);
UpdateInfo(handles,'The region-of-interest is selected.');
function handles=clear_ROI(handles)
handles.DSegOperator.Config.PreProcessConfig.ROI=[];
% Clear Results
handles=ClearALLSegmentationResults(handles);
function handles=update_ROI_Info(handles)
if(handles.DSegOperator.Config.PreProcessConfig.ROI_ON==1)
    ROI=handles.DSegOperator.Config.PreProcessConfig.ROI;
    set(handles.checkbox_ROI_Active,'Value',1);
    if(isempty(ROI))
        [ROIx,ROIy,~]=size(handles.DSegOperator.Config.Frame);
        ROI=[1 1 ROIx-1 ROIy-1];
        set(handles.checkbox_ROI_Active,'Value',0);
    end
else
    [ROIx,ROIy,~]=size(handles.DSegOperator.Config.Frame);
    ROI=[1 1 ROIx-1 ROIy-1];
    set(handles.checkbox_ROI_Active,'Value',0);
end
set(handles.Text_ROI_Image_Size,'String',['H[',num2str(ROI(1),'%d') ,', '...
    num2str(ROI(1)+ROI(3),'%d') ,'] ',...
    'V[',num2str(ROI(2),'%d') ,', '...
    num2str(ROI(2)+ROI(4),'%d') ,']']);


set(handles.Text_TemplateSize,'String',['Size [',num2str((ROI(3)+1)*handles.DSegOperator.Config.PreProcessConfig.Resize.Num,'%d') ,', '...
    num2str((ROI(4)+1)*handles.DSegOperator.Config.PreProcessConfig.Resize.Num,'%d') ,'] ']);

% Resize
function checkbox_Resize_Callback(hObject, eventdata, handles)
CheckValue=get(hObject,'Value');
if(CheckValue==1)
    UpdateInfo(handles,'Resize the region-of-interest.');
    handles.DSegOperator.Config.PreProcessConfig.Resize.On=1;
    set(handles.TEXT_ResizeNumber,'Enable','on');
else
    handles.DSegOperator.Config.PreProcessConfig.Resize.On=0;
    handles.DSegOperator.Config.PreProcessConfig.Resize.Num=1;
    set(handles.TEXT_ResizeNumber,'Enable','off');
    set(handles.TEXT_ResizeNumber,'String',handles.DSegOperator.Config.PreProcessConfig.Resize.Num);
end
% Update Image
handles=UpdatePreProcessNDetectionNoSeedPoint(handles);
handles=update_ROI_Info(handles);
guidata(hObject, handles);
function TEXT_ResizeNumber_Callback(hObject, eventdata, handles)
Numstring=get(hObject,'String');
if(isempty(Numstring))
    set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Resize.Num));
    guidata(hObject, handles);
    return
end
[ResizeNumber, status] = str2num(Numstring);
if(status==0)
    set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Resize.Num));
    guidata(hObject, handles);
    return
end
if(ResizeNumber>0 && ResizeNumber<=10)
    handles.DSegOperator.Config.PreProcessConfig.Resize.Num=round(10*ResizeNumber)/10;
else
    set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Resize.Num,'%10.1f'));
    return
end
set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Resize.Num,'%10.1f'));
handles=UpdateObjectLengthRange(handles);
handles=UpdatePreProcessNDetectionNoSeedPoint(handles);
handles=update_ROI_Info(handles);
guidata(hObject, handles);

function TEXT_ResizeNumber_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
% Invert Inensity
function checkbox_InvertIntensity_Callback(hObject, eventdata, handles)
CheckValue=get(hObject,'Value');
if(CheckValue==1)
    % UpdateParametersSetting
    UpdateInfo(handles,'Invert image intensity values.');
    handles.DSegOperator.Config.PreProcessConfig.InverseIntensity=1;
else
    % UpdateParametersSetting
    UpdateInfo(handles,'Use original image intensity values.');
    handles.DSegOperator.Config.PreProcessConfig.InverseIntensity=0;
end
% Update Image
handles=UpdatePreProcessNDetectionNoSeedPoint(handles);
guidata(hObject, handles);
% Filters
% Median
function checkbox_MedianFilter_Callback(hObject, eventdata, handles)
CheckValue=get(hObject,'Value');
if(CheckValue==1)
    UpdateInfo(handles,'Apply median filter to remove noise.');
    handles.DSegOperator.Config.PreProcessConfig.Medfilt=1;
    set(handles.Slider_KernelSize,'Enable','on');
    set(handles.TEXT_MedianKernelSizeValue,'Enable','on');
else
    handles.DSegOperator.Config.PreProcessConfig.Medfilt=0;
    set(handles.Slider_KernelSize,'Enable','off');
    set(handles.TEXT_MedianKernelSizeValue,'Enable','off');
end
% Update Image
handles=UpdatePreProcessNDetectionNoSeedPoint(handles);
guidata(hObject, handles);
function Slider_KernelSize_Callback(hObject, eventdata, handles)
CheckValue=get(hObject,'Value');
handles.DSegOperator.Config.PreProcessConfig.KernelSize=round(CheckValue);
% Update Image
handles=updateMedianKernel(handles);
guidata(hObject, handles);
function Slider_KernelSize_CreateFcn(hObject, eventdata, handles)
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end
function TEXT_MedianKernelSizeValue_Callback(hObject, eventdata, handles)
Numstring=get(hObject,'String');
if(isempty(Numstring))
    set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.KernelSize,'%10.0f'));
    guidata(hObject, handles);
    return
end
[Ksize, status] = str2num(Numstring);
if(status==0)
    set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.KernelSize,'%10.0f'));
    guidata(hObject, handles);
    return
end
if(Ksize>=0)
    handles.DSegOperator.Config.PreProcessConfig.KernelSize=round(Ksize);
else
    set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.KernelSize,'%10.0f'));
    return
end
set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.KernelSize,'%10.0f'));
guidata(hObject, handles);
function TEXT_MedianKernelSizeValue_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function handles=updateMedianKernel(handles)
% Update image
handles=UpdatePreProcessNDetectionNoSeedPoint(handles);
% Update GUI
set(handles.Slider_KernelSize,'Value',handles.DSegOperator.Config.PreProcessConfig.KernelSize);
set(handles.TEXT_MedianKernelSizeValue,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.KernelSize,'%10.0f'));
% Gaussian
function checkbox_GaussianFilter_Callback(hObject, eventdata, handles)
CheckValue=get(hObject,'Value');
if(CheckValue==1)
    UpdateInfo(handles,'Apply gaussian filters to remove noise.');
    handles.DSegOperator.Config.PreProcessConfig.Gaussian.On=1;
    set(handles.Slider_GaussianKernelSize,'Enable','on');
    set(handles.TEXT_GaussianKernelSizeValue,'Enable','on');
    set(handles.TEXT_GaussianKernelVarianceValue,'Enable','on');
else
    handles.DSegOperator.Config.PreProcessConfig.Gaussian.On=0;
    set(handles.Slider_GaussianKernelSize,'Enable','off');
    set(handles.TEXT_GaussianKernelSizeValue,'Enable','off');
    set(handles.TEXT_GaussianKernelVarianceValue,'Enable','off');
end
% Update Image
handles=updateGaussianKernel(handles);
guidata(hObject, handles);
function Slider_GaussianKernelSize_Callback(hObject, eventdata, handles)
CheckValue=get(hObject,'Value');
handles.DSegOperator.Config.PreProcessConfig.Gaussian.KernelSize=round(CheckValue);
handles.DSegOperator.Config.PreProcessConfig.Gaussian.Variance=(2*handles.DSegOperator.Config.PreProcessConfig.Gaussian.KernelSize+1)/3;
handles.DSegOperator.Config.PreProcessConfig.Gaussian.Kernel=fspecial('gaussian',...
    [2*handles.DSegOperator.Config.PreProcessConfig.Gaussian.KernelSize+1 ...
    2*handles.DSegOperator.Config.PreProcessConfig.Gaussian.KernelSize+1],...
    handles.DSegOperator.Config.PreProcessConfig.Gaussian.Variance);
% Update Image
handles=UpdatePreProcessNDetectionNoSeedPoint(handles);
handles=updateGaussianKernel(handles);
guidata(hObject, handles);
function Slider_GaussianKernelSize_CreateFcn(hObject, eventdata, handles)
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end
function TEXT_GaussianKernelSizeValue_Callback(hObject, eventdata, handles)
Numstring=get(hObject,'String');
if(isempty(Numstring))
    set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Gaussian.KernelSize,'%10.0f'));
    guidata(hObject, handles);
    return
end
[Ksize, status] = str2num(Numstring);
if(status==0)
    set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Gaussian.KernelSize,'%10.0f'));
    guidata(hObject, handles);
    return
end
if(Ksize>=0)
    handles.DSegOperator.Config.PreProcessConfig.Gaussian.KernelSize=round(Ksize);
    handles.DSegOperator.Config.PreProcessConfig.Gaussian.Kernel=fspecial('gaussian',...
        [2*handles.DSegOperator.Config.PreProcessConfig.Gaussian.KernelSize+1 ...
        2*handles.DSegOperator.Config.PreProcessConfig.Gaussian.KernelSize+1],...
        handles.DSegOperator.Config.PreProcessConfig.Gaussian.Variance);
else
    set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Gaussian.KernelSize,'%10.0f'));
    return
end
set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Gaussian.KernelSize,'%10.0f'));
handles=updateGaussianKernel(handles);
guidata(hObject, handles);
function TEXT_GaussianKernelSizeValue_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function TEXT_GaussianKernelVarianceValue_Callback(hObject, eventdata, handles)
Numstring=get(hObject,'String');
if(isempty(Numstring))
    set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Gaussian.Variance,'%10.2f'));
    guidata(hObject, handles);
    return
end
[Ksize, status] = str2num(Numstring);
if(status==0)
    set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Gaussian.Variance,'%10.2f'));
    guidata(hObject, handles);
    return
end
if(Ksize>=0)
    handles.DSegOperator.Config.PreProcessConfig.Gaussian.Variance=Ksize;
    handles.DSegOperator.Config.PreProcessConfig.Gaussian.Kernel=fspecial('gaussian',...
        [2*handles.DSegOperator.Config.PreProcessConfig.Gaussian.KernelSize+1 ...
        2*handles.DSegOperator.Config.PreProcessConfig.Gaussian.KernelSize+1],...
        handles.DSegOperator.Config.PreProcessConfig.Gaussian.Variance);
else
    set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Gaussian.Variance,'%10.2f'));
    return
end
set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Gaussian.Variance,'%10.2f'));
handles=updateGaussianKernel(handles);
guidata(hObject, handles);
function TEXT_GaussianKernelVarianceValue_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function handles=updateGaussianKernel(handles)
% Update image
handles=UpdatePreProcessNDetectionNoSeedPoint(handles);
% Update GUI
set(handles.Slider_GaussianKernelSize,'Value',handles.DSegOperator.Config.PreProcessConfig.Gaussian.KernelSize);
set(handles.TEXT_GaussianKernelSizeValue,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Gaussian.KernelSize,'%10.0f'));
set(handles.TEXT_GaussianKernelVarianceValue,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Gaussian.Variance,'%10.2f'));
% Anisotropic filter
function checkbox_AnisotropicFilter_Callback(hObject, eventdata, handles)
CheckValue=get(hObject,'Value');
if(CheckValue==1)
    UpdateInfo(handles,'Apply anisotropic filters to remove noise.');
    handles.DSegOperator.Config.PreProcessConfig.Aniso=1;
    set(handles.TEXT_Aniso_iteration,'Enable','on');
    set(handles.TEXT_Aniso_iteration,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Aniso_iteration,'%d'));
    set(handles.TEXT_Aniso_step,'Enable','on');
    set(handles.TEXT_Aniso_step,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Aniso_step,'%10.2f'));
    set(handles.TEXT_Aniso_kappa,'Enable','on');
    set(handles.TEXT_Aniso_kappa,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Aniso_kappa,'%10.2f'));
else
    handles.DSegOperator.Config.PreProcessConfig.Aniso=0;
    set(handles.TEXT_Aniso_iteration,'Enable','off');
    set(handles.TEXT_Aniso_step,'Enable','off');
    set(handles.TEXT_Aniso_kappa,'Enable','off');
end
% Update Image
handles=UpdatePreProcessNDetectionNoSeedPoint(handles);
guidata(hObject, handles);
function TEXT_Aniso_iteration_Callback(hObject, eventdata, handles)
Numstring=get(hObject,'String');
if(isempty(Numstring))
    set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Aniso_iteration));
    guidata(hObject, handles);
    return
end
[Aniso_iteration, status] = str2num(Numstring);
if(status==0)
    set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Aniso_iteration));
    guidata(hObject, handles);
    return
end
if(Aniso_iteration>0 && Aniso_iteration<=10)
    handles.DSegOperator.Config.PreProcessConfig.Aniso_iteration=round(Aniso_iteration);
else
    set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Aniso_iteration,'%d'));
    return
end
set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Aniso_iteration,'%d'));
handles=UpdatePreProcessNDetectionNoSeedPoint(handles);
guidata(hObject, handles);
function TEXT_Aniso_iteration_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function TEXT_Aniso_step_Callback(hObject, eventdata, handles)
Numstring=get(hObject,'String');
if(isempty(Numstring))
    set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Aniso_step));
    guidata(hObject, handles);
    return
end
[Aniso_step, status] = str2num(Numstring);
if(status==0)
    set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Aniso_step));
    guidata(hObject, handles);
    return
end
if(Aniso_step>0 && Aniso_step<=10)
    handles.DSegOperator.Config.PreProcessConfig.Aniso_step=Aniso_step;
else
    set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Aniso_step,'%10.2f'));
    return
end
set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Aniso_step,'%10.2f'));
handles=UpdatePreProcessNDetectionNoSeedPoint(handles);
guidata(hObject, handles);
function TEXT_Aniso_step_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function TEXT_Aniso_kappa_Callback(hObject, eventdata, handles)
Numstring=get(hObject,'String');
if(isempty(Numstring))
    set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Aniso_kappa,'%10.2f'));
    guidata(hObject, handles);
    return
end
[Aniso_kappa, status] = str2num(Numstring);
if(status==0)
    set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Aniso_kappa,'%10.2f'));
    guidata(hObject, handles);
    return
end
if(Aniso_kappa>0 && Aniso_kappa<=10)
    handles.DSegOperator.Config.PreProcessConfig.Aniso_kappa=Aniso_kappa;
else
    set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Aniso_kappa,'%10.2f'));
    return
end
set(hObject,'String',num2str(handles.DSegOperator.Config.PreProcessConfig.Aniso_kappa,'%10.2f'));
handles=UpdatePreProcessNDetectionNoSeedPoint(handles);
guidata(hObject, handles);
function TEXT_Aniso_kappa_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
% Background Subtraction
function checkbox_BackgroundSub_Callback(hObject, eventdata, handles)
CheckValue=get(hObject,'Value');
if(CheckValue==1)
    handles.DSegOperator.Config.PreProcessConfig.Backgroundsubtraction=1;
    set(handles.popupmenu_BackgroundSubtraction,'Enable','on');
    switch handles.DSegOperator.Config.PreProcessConfig.BackgroundsubtractionMethod
        case 'Gaussian'
            set(handles.popupmenu_BackgroundSubtraction,'Value',1);
            set(handles.slider_BackgroundSubGaussianKernel,'Enable','on');
        case 'Gaussian Norm'
            set(handles.popupmenu_BackgroundSubtraction,'Value',2);
            set(handles.slider_BackgroundSubGaussianKernel,'Enable','on');
    end
else
    handles.DSegOperator.Config.PreProcessConfig.Backgroundsubtraction=0;
    set(handles.popupmenu_BackgroundSubtraction,'Enable','off');
end
% Update Image
handles=UpdatePreProcessNDetectionNoSeedPoint(handles);
guidata(hObject, handles);
function popupmenu_BackgroundSubtraction_Callback(hObject, eventdata, handles)
contents = cellstr(get(hObject,'String'));
CurrentString=contents{get(hObject,'Value')};
switch CurrentString
    case 'Gaussian (Subtract)'
        handles.DSegOperator.Config.PreProcessConfig.BackgroundsubtractionMethod='Gaussian';
        set(handles.slider_BackgroundSubGaussianKernel,'Enable','on');
    case 'Gaussian (Divide)'
        handles.DSegOperator.Config.PreProcessConfig.BackgroundsubtractionMethod='Gaussian Norm';
        set(handles.slider_BackgroundSubGaussianKernel,'Enable','on');
    otherwise
        handles.DSegOperator.Config.PreProcessConfig.BackgroundsubtractionMethod='Gaussian';
        set(handles.slider_BackgroundSubGaussianKernel,'Enable','on');
end
% Update Frame
handles=UpdatePreProcessNDetectionNoSeedPoint(handles);
handles=UpdateFrameNum(handles);
guidata(hObject, handles);
function popupmenu_BackgroundSubtraction_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function slider_BackgroundSubGaussianKernel_Callback(hObject, eventdata, handles)
CheckValue=get(hObject,'Value');
handles.DSegOperator.Config.PreProcessConfig.Backgroundsub.Gaussian.KernelSize=round(CheckValue);
handles.DSegOperator.Config.PreProcessConfig.Backgroundsub.Gaussian.Variance=(2*handles.DSegOperator.Config.PreProcessConfig.Backgroundsub.Gaussian.KernelSize+1)/3;
handles.DSegOperator.Config.PreProcessConfig.Backgroundsub.Gaussian.Kernel=fspecial('gaussian',...
    [2*handles.DSegOperator.Config.PreProcessConfig.Backgroundsub.Gaussian.KernelSize+1 ...
    2*handles.DSegOperator.Config.PreProcessConfig.Backgroundsub.Gaussian.KernelSize+1],...
    handles.DSegOperator.Config.PreProcessConfig.Backgroundsub.Gaussian.Variance);
% Update Image
handles=UpdatePreProcessNDetectionNoSeedPoint(handles);
guidata(hObject, handles);
function slider_BackgroundSubGaussianKernel_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end
% Intensity scaling
function checkbox_Rescaling_Callback(hObject, eventdata, handles)
CheckValue=get(hObject,'Value');
if(CheckValue==1)
    handles.DSegOperator.Config.PreProcessConfig.IntensityRescaling=1;
else
    handles.DSegOperator.Config.PreProcessConfig.IntensityRescaling=0;
end
% Update Image
handles=UpdatePreProcessNDetectionNoSeedPoint(handles);
guidata(hObject, handles);
% Thresholding
function handles=UpdateThesholdChanges(handles,CheckValue)
handles.DSegOperator.SetMask(imbinarize(handles.DSegOperator.Image,max(0.01,CheckValue)));
%% Detection
% Thresholding
function checkbox_AutoThreshold_Callback(hObject, eventdata, handles)
CheckValue=get(hObject,'Value');
if(CheckValue==1)
    handles.DSegOperator.Config.DetectionConfig.AutoThresh=1;
    handles.DSegOperator.Config.DetectionConfig.AutoThreshOffset=0;
else
    handles.DSegOperator.Config.DetectionConfig.AutoThresh=0;
end
% Update Image
handles=UpdateDetectionMaskNoSeedPoint(handles);
guidata(hObject, handles);
function TEXT_AutoThreshOffSetValue_Callback(hObject, eventdata, handles)
Numstring=get(hObject,'String');
if(isempty(Numstring))
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.AutoThreshOffset,'%10.3f'));
    guidata(hObject, handles);
    return
end
[AutoThreshOffSet, status] = str2num(Numstring);
if(status==0)
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.AutoThreshOffset,'%10.3f'));
    guidata(hObject, handles);
    return
end
Threshvalue=handles.DSegOperator.Config.DetectionConfig.EdgeThresh;
if(Threshvalue+AutoThreshOffSet>0 && Threshvalue+AutoThreshOffSet<1 && AutoThreshOffSet>=-1 && AutoThreshOffSet<=1)
    handles.DSegOperator.Config.DetectionConfig.AutoThreshOffset=AutoThreshOffSet;
else
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.AutoThreshOffset,'%10.3f'));
    return
end

% Update Image
handles=UpdatePreProcessNDetectionNoSeedPoint(handles);
% Update
guidata(hObject, handles);
function TEXT_AutoThreshOffSetValue_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function Slider_AutoThreshOffSet_Callback(hObject, eventdata, handles)
AutoThreshOffSet=get(hObject,'Value');
Threshvalue=handles.DSegOperator.Config.DetectionConfig.EdgeThresh;
if(Threshvalue+AutoThreshOffSet>0 && Threshvalue+AutoThreshOffSet<1 && AutoThreshOffSet>=-1 && AutoThreshOffSet<=1)
    handles.DSegOperator.Config.DetectionConfig.AutoThreshOffset=AutoThreshOffSet;
else
    set(hObject,'Value',handles.DSegOperator.Config.DetectionConfig.AutoThreshOffset);
    return
end
set(hObject,'value',handles.DSegOperator.Config.DetectionConfig.AutoThreshOffset);
set(handles.TEXT_AutoThreshOffSetValue,'String',num2str(handles.DSegOperator.Config.DetectionConfig.AutoThreshOffset,'%10.3f'));
% Update Image
handles=UpdateDetectionMaskNoSeedPoint(handles);
guidata(hObject, handles);
function Slider_AutoThreshOffSet_CreateFcn(hObject, eventdata, handles)
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end
function Slider_Theshold_Callback(hObject, eventdata, handles)
Threshvalue=get(hObject,'Value');
set(handles.checkbox_AutoThreshold,'Value',0);
handles.DSegOperator.Config.DetectionConfig.AutoThresh=0;
handles.DSegOperator.Config.DetectionConfig.AdaptiveThresh=0;

offsetvalue=handles.DSegOperator.Config.DetectionConfig.AutoThreshOffset;
if(offsetvalue+Threshvalue>0 && offsetvalue+Threshvalue<1 && Threshvalue>=0 && Threshvalue<=1)
    handles.DSegOperator.Config.DetectionConfig.EdgeThresh=Threshvalue;
else
    set(hObject,'Value',handles.DSegOperator.Config.DetectionConfig.EdgeThresh);
    return
end
% Update Image
set(handles.TEXT_ThreshValue,'String',num2str(handles.DSegOperator.Config.DetectionConfig.EdgeThresh,'%10.3f'));
handles=UpdateDetectionMaskNoSeedPoint(handles);
guidata(hObject, handles);
function Slider_Theshold_CreateFcn(hObject, eventdata, handles)
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end
function TEXT_ThreshValue_Callback(hObject, eventdata, handles)
Numstring=get(hObject,'String');
if(isempty(Numstring))
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.EdgeThresh,'%10.3f'));
    guidata(hObject, handles);
    return
end
[Threshvalue, status] = str2num(Numstring);
if(status==0)
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.EdgeThresh,'%10.3f'));
    guidata(hObject, handles);
    return
end
offsetvalue=handles.DSegOperator.Config.DetectionConfig.AutoThreshOffset;
if(Threshvalue>=0 && Threshvalue<=1)
    
    handles.DSegOperator.Config.DetectionConfig.AutoThresh=0;
    set(handles.checkbox_AutoThreshold,'Value',0);
    
    handles.DSegOperator.Config.DetectionConfig.AdaptiveThresh=0;
    
    handles.DSegOperator.Config.DetectionConfig.AutoThreshOffset=0;
    set(handles.TEXT_AutoThreshOffSetValue,'String',num2str(handles.DSegOperator.Config.DetectionConfig.AutoThreshOffset,'%10.3f'));
    
    handles.DSegOperator.Config.DetectionConfig.EdgeThresh=Threshvalue;
else
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.EdgeThresh,'%10.3f'));
    return
end

% Update Image
handles=UpdateDetectionMaskNoSeedPoint(handles);
guidata(hObject, handles);
function TEXT_ThreshValue_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function Button_AdaptiveThresholding_Callback(hObject, eventdata, handles)
Value=get(hObject,'Value');
if(Value==1)
    set(handles.check_ShowMask,'Value',1);
    handles.DSegOperator.Config.DetectionConfig.ShowMask=1;
    handles.DSegOperator.Config.DetectionConfig.AdaptiveThresh=1;
    set(handles.Slider_Theshold,'Enable','off');
    set(handles.TEXT_ThreshValue,'Enable','off');
end
handles=UpdatePreProcessNDetectionNoSeedPoint(handles);
function Button_GlobalThresholding_Callback(hObject, eventdata, handles)
Value=get(hObject,'Value');
if(Value==1)
    set(handles.check_ShowMask,'Value',1);
    handles.DSegOperator.Config.DetectionConfig.ShowMask=1;
    handles.DSegOperator.Config.DetectionConfig.AdaptiveThresh=0;
    set(handles.Slider_Theshold,'Enable','on');
    set(handles.TEXT_ThreshValue,'Enable','on');
end
handles=UpdatePreProcessNDetectionNoSeedPoint(handles);
% Levelset method
function handles=SingleCell_UpdateValueOne(handles)
set(handles.TEXT_LevelSet_Istrength,'String',num2str(handles.DSegOperator.Config.DetectionConfig.LEVELSET.Istrength,'%10.2f'));
set(handles.TEXT_LevelSet_Gstrength,'String',num2str(handles.DSegOperator.Config.DetectionConfig.LEVELSET.Gstrength,'%10.1f'));
set(handles.TEXT_LevelSetBranchArea,'String',num2str(handles.DSegOperator.Config.DetectionConfig.LEVELSET.MaxMergeSize,'%10.0f'));
set(handles.Button_SelectCells,'Enable','on');
handles.DSegOperator.Config.DetectionConfig.Method.Name='SingleCellDetection';
function TEXT_LevelSet_Istrength_Callback(hObject, eventdata, handles)
Numstring=get(hObject,'String');
if(isempty(Numstring))
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.LEVELSET.Istrength));
    guidata(hObject, handles);
    return
end
[Istrength, status] = str2num(Numstring);
if(status==0)
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.LEVELSET.Istrength));
    guidata(hObject, handles);
    return
end
if(Istrength>=-1 && Istrength<=1)
    handles.DSegOperator.Config.DetectionConfig.LEVELSET.Istrength=Istrength;
else
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.LEVELSET.Istrength,'%10.2f'));
    return
end
set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.LEVELSET.Istrength,'%10.2f'));
guidata(hObject, handles);
function TEXT_LevelSet_Istrength_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function TEXT_LevelSet_Gstrength_Callback(hObject, eventdata, handles)
Numstring=get(hObject,'String');
if(isempty(Numstring))
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.LEVELSET.Gstrength));
    guidata(hObject, handles);
    return
end
[Gstrength, status] = str2num(Numstring);
if(status==0)
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.LEVELSET.Gstrength));
    guidata(hObject, handles);
    return
end
if(Gstrength>=0 && Gstrength<=10)
    handles.DSegOperator.Config.DetectionConfig.LEVELSET.Gstrength=Gstrength;
else
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.LEVELSET.Gstrength,'%10.1f'));
    return
end
set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.LEVELSET.Gstrength,'%10.1f'));
guidata(hObject, handles);
function TEXT_LevelSet_Gstrength_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function TEXT_LevelSetBranchArea_Callback(hObject, eventdata, handles)
Numstring=get(hObject,'String');
if(isempty(Numstring))
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.LEVELSET.MaxMergeSize));
    guidata(hObject, handles);
    return
end
[BranchArea, status] = str2num(Numstring);
if(status==0)
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.LEVELSET.MaxMergeSize));
    guidata(hObject, handles);
    return
end
if(BranchArea>=0 && BranchArea<=10000)
    handles.DSegOperator.Config.DetectionConfig.LEVELSET.MaxMergeSize=BranchArea;
else
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.LEVELSET.MaxMergeSize,'%10.1f'));
    return
end
set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.LEVELSET.MaxMergeSize,'%10.1f'));
guidata(hObject, handles);
function TEXT_LevelSetBranchArea_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
%% ѡȡobject
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Button_SelectCells_Callback(hObject, eventdata, handles)
% Construct a questdlg with three options
choice = questdlg('Clear all the result files and start a new detection?', ...
    'Detection ', ...
    'Yes','No','No');
switch choice
    case 'Yes'
        set(handles.check_ShowMask,'Value',1);
        handles.DSegOperator.Config.DetectionConfig.ShowMask=1;
        handles=ClearALLSegmentationResults(handles);
    case 'No'
        return;
end
% Update Selections
handles.DSegOperator.Config.DetectionConfig.Add=1;

if(handles.DSegOperator.Config.DetectionConfig.AutoSelect==1)
    UpdateInfo(handles,'Processing now, please wait...'); 
    handles.DSegOperator.Preprocess(handles.DSegOperator.Config.Frame);
    handles.DSegOperator.Config.DetectionConfig.Method.Name='AutoDetection';
    handles.DSegOperator.Detect(handles.DSegOperator.Image,1);
    handles.DSegOperator.Config.DetectionConfig.Method.Name='SingleCellDetection';
    if(handles.DSegOperator.Config.DetectionConfig.ValidMask==1)
        handles.DSegOperator.Config.DetectionConfig.Current.ID=length(handles.DSegOperator.Detection);
    end
    updateSelectedObjectList(handles);
    % Update Slide
    set(handles.Slider_FrameNumber,'Value',handles.DSegOperator.Config.AVIobj.CurrentTime*handles.DSegOperator.Config.AVIobj.FrameRate+1);
    if(~isempty(handles.DSegOperator.Detection))
        set(handles.TEXT_CurrentObjectID,'String',num2str(handles.DSegOperator.Detection(handles.DSegOperator.Config.DetectionConfig.Current.ID).Id));
        handles=updateButtonDetection(handles,'on');
        UpdateInfo(handles,'Detection completed.');
    else
        UpdateInfoColor(handles,'No objects detected, please set the object length properly.',[1 0 0]);
        handles=updateButtonDetection(handles,'off');
    end
    handles=UpdateAllResults(handles);
else
    % Init Parameters
    UpdateInfoColor(handles,'Click on each object of interest, double click on the last object.',[0 1 0]);
    startingframe=handles.DSegOperator.Config.FrameNum;
    if(startingframe>0)
        handles.DSegOperator.Config.AVIobj.CurrentTime = double(startingframe-1)/handles.DSegOperator.Config.AVIobj.FrameRate;
    end
    if(~isempty(handles.DSegOperator.Config.AVIobj.Name))
        handles.DSegOperator.Config.Frame=readFrame(handles.DSegOperator.Config.AVIobj);
    end
    handles=UpdateFrameNum(handles);
    [x_all, y_all]=GetPointsFromImage(handles);
    % Init seed
    handles=initSelectionParameters(handles);
    for i_xy=1:length(x_all)
        % Init seed
        handles.DSegOperator.Config.DetectionConfig.Method.SEED=[x_all(i_xy) y_all(i_xy)];
        handles.DSegOperator.Preprocess(handles.DSegOperator.Config.Frame);
        handles.DSegOperator.Detect(handles.DSegOperator.Image,1);
        if(handles.DSegOperator.Config.DetectionConfig.ValidMask==1)
            handles.DSegOperator.Config.DetectionConfig.Current.ID=length(handles.DSegOperator.Detection);
            handles.DSegOperator.Config.DetectionConfig.Current.ApplyID=handles.DSegOperator.Config.DetectionConfig.Current.ID;
        end
        updateSelectedObjectList(handles);
        % Update Slide
        set(handles.Slider_FrameNumber,'Value',handles.DSegOperator.Config.AVIobj.CurrentTime*handles.DSegOperator.Config.AVIobj.FrameRate+1);
    end
    if(~isempty(handles.DSegOperator.Detection))
        
        handles=UpdateAllResults(handles);
        set(handles.TEXT_CurrentObjectID,'String',num2str(handles.DSegOperator.Detection(handles.DSegOperator.Config.DetectionConfig.Current.ID).Id));
        
        handles=updateButtonDetection(handles,'on');
        UpdateInfo(handles,'Detection completed.');
    else

        handles=updateButtonDetection(handles,'off');
        if(~isempty(x_all))
         UpdateInfoColor(handles,'No objects detected, please click on objects and set the object length properly.',[1 0 0]);
        end
    end
end
%%
handles.DSegOperator.Config.DetectionConfig.Add=0;
guidata(hObject, handles);
function handles=updateButtonDetection(handles,option)
set(handles.Button_SegmentationAll,'Enable',option);
set(handles.Button_Pause,'Enable',option);
set(handles.Button_Stop,'Enable',option);
set(handles.Button_Forward,'Enable',option);
set(handles.Button_InitMask,'Enable',option);
set(handles.Button_CheckDetection,'Enable',option);
set(handles.pushbutton_SelectObject,'Enable',option);
set(handles.pushbutton_disconnect,'Enable',option);
set(handles.pushbutton_connect,'Enable',option);
set(handles.checkbox_ShowSkeletonMaskNoBranch,'Enable',option);
set(handles.StaticObjectParameterSettings,'Enable',option);

function handles=updateExtraManualRefinement(handles)

function [x_all, y_all]=GetPointsFromImage(handles)
handles.DSegOperator.Config.DetectionConfig.Method.SEED=[];
handles.DSegOperator.Preprocess(handles.DSegOperator.Config.Frame);
handles.DSegOperator.Detect(handles.DSegOperator.Image,1);
figure(handles.figure_CGTracking)
axes(handles.MainAxes_FrameDisplay);
axes1_handle=gca;
ImagePresent=imfuse(handles.DSegOperator.DetectionMask,handles.DSegOperator.Image,'blend','Scaling','joint');
imshow(ImagePresent);
try
    [y_all, x_all] =getpts(axes1_handle);
    list=zeros(length(y_all),4);
    list(:,1)=y_all<0;
    list(:,2)=y_all>size(handles.DSegOperator.Image,2);
    list(:,3)=x_all<0;
    list(:,4)=x_all>size(handles.DSegOperator.Image,1);
    y_all=y_all(sum(list,2)==0);
    x_all=x_all(sum(list,2)==0);
catch
    x_all=[];
    y_all=[];
    UpdateInfoColor(handles,'Faieled to find objects. Please remember to double click on the last object.',[1 0 0]);
end
function [x_all_out, y_all_out]=GetPointsOnly(handles,axes1_handle)
x_all_out=[];
y_all_out=[];
try
    [y_all, x_all] =getpts(axes1_handle);
    list=zeros(length(y_all),4);
    list(:,1)=y_all<0;
    list(:,2)=y_all>size(handles.DSegOperator.Image,2);
    list(:,3)=x_all<0;
    list(:,4)=x_all>size(handles.DSegOperator.Image,1);
    y_all=y_all(sum(list,2)==0);
    x_all=x_all(sum(list,2)==0);
catch
    UpdateInfoColor(handles,'Faieled to find objects. Please remember to double click on the last object.',[1 0 0]);
    return
end
if(~isempty(x_all))
    % Increase this area to make the clicking easier
    P_area=5;
    P_Cent=round(P_area/2);
    [X,Y] = meshgrid(1:P_area,1:P_area);
    for i_x=1:length(x_all)
        x_allt=round(x_all(i_x))-X+P_Cent;
        x_all_out=[x_all_out; x_allt(:)];
        y_allt=round(y_all(i_x))-Y+P_Cent;
        y_all_out=[y_all_out; y_allt(:)]; 
    end
end

function handles=initSelectionParameters(handles)
handles.DSegOperator.Config.DetectionConfig.SingleCell=1;
handles.DSegOperator.Config.DetectionConfig.Method.Name='SingleCellDetection';
handles.DSegOperator.Config.DetectionConfig.ShowSkeletonMask=1;
%handles.DSegOperator.Config.DetectionConfig.ShowSkeletonNoBranchMask=1;
handles.DSegOperator.Config.DetectionConfig.Method.LEVELSET_MASK=1;
function TEXT_SelectNumofFrames_Callback(hObject, eventdata, handles)
Numstring=get(hObject,'String');
if(isempty(Numstring))
    set(hObject,'String',num2str(handles.DSegOperator.Config.ProcessFrames));
    guidata(hObject, handles);
    return
end
[PFrameNumber, status] = str2num(Numstring);
if(status==0)
    set(hObject,'String',num2str(handles.DSegOperator.Config.ProcessFrames));
    guidata(hObject, handles);
    return
end
if(PFrameNumber>=1 && PFrameNumber<=round(handles.DSegOperator.Config.AVIobj.FrameRate*(handles.DSegOperator.Config.AVIobj.Duration-handles.DSegOperator.Config.AVIobj.CurrentTime)))
    handles.DSegOperator.Config.ProcessFrames=PFrameNumber;
elseif(PFrameNumber==0)
    handles.DSegOperator.Config.ProcessFrames=round(handles.DSegOperator.Config.AVIobj.FrameRate*(handles.DSegOperator.Config.AVIobj.Duration-handles.DSegOperator.Config.AVIobj.CurrentTime));
else
    set(hObject,'String',num2str(handles.DSegOperator.Config.ProcessFrames));
    return
end
set(hObject,'String',num2str(handles.DSegOperator.Config.ProcessFrames));
handles=updateProcessEndFrame(handles);
guidata(hObject, handles);
function TEXT_SelectNumofFrames_CreateFcn(hObject, eventdata, handles)
% hObject    handle to TEXT_SelectNumofFrames (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
% չʾ Mask
function check_ShowMask_Callback(hObject, eventdata, handles)
CheckValue=get(hObject,'Value');
if(CheckValue==1)
    UpdateInfo(handles,'Display the image with thresholding results');
    handles.DSegOperator.Config.DetectionConfig.ShowMask=1;
    set(handles.checkbox_showSkeletonMask,'Enable','on');
    set(handles.checkbox_ShowSkeletonMaskNoBranch,'Enable','on');
    set(handles.StaticObjectParameterSettings,'Enable','on');
else
    UpdateInfo(handles,'Display the pre-processed image');
    handles.DSegOperator.Config.DetectionConfig.ShowMask=0;
    handles.DSegOperator.Config.DetectionConfig.ShowSkeletonMask=0;
    set(handles.checkbox_showSkeletonMask,'Enable','off');
    set(handles.checkbox_ShowSkeletonMaskNoBranch,'Enable','off');
    set(handles.StaticObjectParameterSettings,'Enable','off');
    handles.DSegOperator.Config.DetectionConfig.UpdateMask='0';
end
% Update Image
handles=UpdatePreprocessing(handles);
guidata(hObject, handles);
function checkbox_showSkeletonMask_Callback(hObject, ~, handles)
CheckValue=get(hObject,'Value');
if(CheckValue==1)
    handles.DSegOperator.Config.DetectionConfig.ShowSkeletonMask=1;
    set(handles.checkbox_ShowSkeletonMaskNoBranch,'Enable','on');
    set(handles.StaticObjectParameterSettings,'Enable','on');
else
    handles.DSegOperator.Config.DetectionConfig.ShowSkeletonMask=0;
    set(handles.checkbox_ShowSkeletonMaskNoBranch,'Enable','off');
    set(handles.StaticObjectParameterSettings,'Enable','off');
    handles.DSegOperator.Config.DetectionConfig.UpdateMask='0';
end
% Update Image
handles=GUI_DisableButtons(handles);
handles=UpdatePreprocessing(handles);
handles=UpdateButtonsLoadVideo(handles);
guidata(hObject, handles);
function checkbox_ShowSkeletonMaskNoBranch_Callback(hObject, ~, handles)
CheckValue=get(hObject,'Value');
if(CheckValue==1)
    UpdateInfo(handles,'Display the image and extracted backbone structure');
    handles.DSegOperator.Config.DetectionConfig.ShowSkeletonNoBranchMask=1;
else
    handles.DSegOperator.Config.DetectionConfig.ShowSkeletonNoBranchMask=0;
end
% Update Image
handles=UpdatePreprocessing(handles);
guidata(hObject, handles);
% Mask
function Button_InitMask_Callback(hObject, eventdata, handles)
CurrentId=handles.DSegOperator.Config.DetectionConfig.Current.ID;
if(isempty(CurrentId) || isempty(handles.DSegOperator.Detection(1).Id))
    return
end
% Init Parameters
handles.DSegOperator.SetDetection(CurrentId,'CurrentFrame',handles.DSegOperator.Detection(CurrentId).StartFrame);

startingframe=handles.DSegOperator.Detection(CurrentId).StartFrame;
handles.DSegOperator.Config.AVIobj.CurrentTime = double(startingframe-1)/handles.DSegOperator.Config.AVIobj.FrameRate;
if(~isempty(handles.DSegOperator.Config.AVIobj.Name))
        handles.DSegOperator.Config.Frame=readFrame(handles.DSegOperator.Config.AVIobj);
end
handles=UpdateFrameNum(handles);

% Init seed
handles.DSegOperator.Config.DetectionConfig.Method.SEED=handles.DSegOperator.Detection(CurrentId).SeedPoints;
handles.DSegOperator.Preprocess(handles.DSegOperator.Config.Frame);
handles.DSegOperator.Detect(handles.DSegOperator.Image,1);
if(handles.DSegOperator.Config.DetectionConfig.ValidMask==1)
    handles.DSegOperator.SetDetection(CurrentId,'Completed',0);
else
    UpdateInfoColor(handles,'Faieled to find seed points. Please delete this object or start a new detection.',[1 0 0]);
end
updateSelectedObjectList(handles);
% Update Slide
set(handles.Slider_FrameNumber,'Value',handles.DSegOperator.Config.AVIobj.CurrentTime*handles.DSegOperator.Config.AVIobj.FrameRate+1);
Present_ImageTemplate(handles);

if(~isempty(handles.DSegOperator.Detection))
    set(handles.TEXT_CurrentObjectID,'String',num2str(handles.DSegOperator.Detection(handles.DSegOperator.Config.DetectionConfig.Current.ID).Id));
    handles=UpdateTempMask(handles);
end
handles=UpdateAfterSegmentation(handles,'on');
guidata(hObject, handles);
%% Backbone structure analysis
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Button_Analyze_Callback(hObject, eventdata, handles)
if(handles.DSegOperator.Config.DetectionConfig.Current.ID==0)
    return
end
% Present analysis result
handles.DSegOperator.Config.AnalysisConfig.Debug=1;
handles.DSegOperator.Analyze(handles.DSegOperator.Config.FrameNum);
handles=UpdateAnalysisResult(handles);
handles.DSegOperator.Config.AnalysisConfig.Debug=0;
guidata(hObject, handles);
function handles=UpdateAnalysisResult(handles)
set(handles.listbox_AnalysisDataList,'BackgroundColor',[1 1 1]);
ResultsData=ReadDetection(handles);
ResultSize=size(ResultsData,1);
if(ResultSize>0)
    DataTemp=ResultsData;
    DataTemp=[DataTemp;handles.DSegOperator.Results.Data];
else
    DataTemp=handles.DSegOperator.Results.Data;
end
if(~isempty(DataTemp))
    Datasize = ResultSize+1;
else
    Datasize = ResultSize;
end
DataString=cell(Datasize,1);
for i=1:Datasize
    DataString{i}=['Frame:' num2str(DataTemp(i,2),'%05.0f'), ' Length (backbone):' num2str(DataTemp(i,9)*1e6,'%10.3f') '   Lp<Cos>:' num2str(DataTemp(i,10),'%10.3f') '   Lp<R2>:' num2str(DataTemp(i,11),'%10.3f')];
end
set(handles.listbox_AnalysisDataList,'String',DataString);
set(handles.listbox_AnalysisDataList,'Value',Datasize);
WriteDetection(handles);
function handles=UpdateAnalysisResultOnlyRead(handles)
ResultsData=ReadDetection(handles);
ResultSize=size(ResultsData,1);
if(ResultSize>0)
    DataTemp=ResultsData;
else
end
DataString=cell(ResultSize,1);
for i=1:ResultSize
    DataString{i}=['Frame:' num2str(DataTemp(i,2),'%05.0f'),' Length (backbone):' num2str(DataTemp(i,9)*1e6,'%10.2f') ' Lp<Cos>:' num2str(DataTemp(i,10),'%10.2f') ' Lp<R2>:' num2str(DataTemp(i,11),'%10.2f')];
end
set(handles.listbox_AnalysisDataList,'String',DataString);
set(handles.listbox_AnalysisDataList,'Value',1);
% list of data
function listbox_AnalysisDataList_Callback(hObject, eventdata, handles)
index_selected = get(hObject,'Value');
handles.DSegOperator.Config.OutputConfig.PresentID=index_selected;
function listbox_AnalysisDataList_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function Button_AnalysisClear_Callback(hObject, eventdata, handles)
if isempty(handles.DSegOperator.Detection(1).Id)
   return 
end
handles=DeteleFile(handles);
handles=UpdateAnalysisResultOnlyRead(handles);
guidata(hObject, handles);
function Button_AnalysisRemove_Callback(hObject, eventdata, handles)
if isempty(handles.DSegOperator.Detection(1).Id)
   return 
end
Path=handles.DSegOperator.Config.OutputConfig.PathDetection;
Name=strcat(handles.DSegOperator.Config.OutputConfig.SavingFileName,num2str(handles.DSegOperator.Detection(handles.DSegOperator.Config.DetectionConfig.Current.ID).Id,'%05.0f'),'.mat');
files = dir(strcat(Path,Name));
if(~isempty(files))
    m = matfile(strcat(Path,Name),'Writable',true);
    DataSize=size(m.ResultsData,1);
    if(DataSize>0)
        index_selected = get(handles.listbox_AnalysisDataList,'Value');
        if(index_selected<=DataSize)
            m.ResultsData(index_selected,:)=[];
        end
    end
end
handles=UpdateAnalysisResultOnlyRead(handles);
guidata(hObject, handles);
function Button_AnalysisPresentResults_Callback(hObject, eventdata, handles)
if(handles.DSegOperator.Config.DetectionConfig.Current.ID==0)
    return
end
% ļ
warning('off','all');
% ͼƬС
[Height,Width]=size(handles.DSegOperator.Image);
AspectR=Height/Width;
% ӡͼ񳤿ͱ߽
Figure_Width = 17.7*2; % cm -- IEEE single column width (210-14.32*2-4.22)/3 = 59.04mm (3 columns in a row)
Figure_OuterMargin=0.3;

% ÿͼƬ,λֱ߽,ִС
SubPlot_Width = 8.5*2; % cm -- IEEE single column width (210-14.32*2-4.22)/3 = 59.04mm (3 columns in a row)
SubPlot_Height = SubPlot_Width*AspectR; % cm ÿͼƬ
Figure_Height = SubPlot_Height+0.5; % cm ӡͼС
SubPlot_TextMargin=1; % 볤ͼƬܳ
Text_SubPlot_FontSize=9;
% ͼƬ legend ķλ΢
SubPlot_Legend_Location='NorthOutside';
SubPlot_Legend_Orientation='vertical'; % з
SubPlot_Legend_WidthShift=1.2; % λ
SubPlot_Legend_HeightShift=7.6; % λ
SubPlot_subLegend_WidthShift=3.5;
SubPlot_subLegend_HeightShift=0;
OuterMargin=0.5;
TextMargin=1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ͼƬλ
SubPlot_SpacingX=SubPlot_Width+0.5; % ͼƬ
SubPlot_SpacingY=0;
SubPlot_Shift_x=0;    % ʵʼ (ʵͼƬΪ׼)
SubPlot_Shift_y=0;
FigHandle = figure(3);
set(FigHandle,'Unit','centimeters')
set(FigHandle,'Position',[10 10 Figure_Width+Figure_OuterMargin Figure_Height+Figure_OuterMargin])
set(FigHandle,'name','Segmentation results','numbertitle','off','Resize','on')
set(FigHandle,'Color','white')
set(FigHandle,'Papertype','a4')
set(FigHandle,'PaperPosition',[0 0 Figure_Width+Figure_OuterMargin Figure_Height+Figure_OuterMargin]);
FigAxe1=axes('Parent',FigHandle,...
    'Units','centimeters',...
    'OuterPosition',[Figure_OuterMargin+SubPlot_Shift_x Figure_OuterMargin+SubPlot_Shift_y SubPlot_Width-Figure_OuterMargin SubPlot_Height-Figure_OuterMargin],...
    'Position',[SubPlot_TextMargin+Figure_OuterMargin+SubPlot_Shift_x SubPlot_TextMargin+Figure_OuterMargin+SubPlot_Shift_y SubPlot_Width-SubPlot_TextMargin-Figure_OuterMargin SubPlot_Height-SubPlot_TextMargin-Figure_OuterMargin],...
    'Box','off',...
    'XGrid','off',...
    'XTick',[],...
    'YGrid','off',...
    'YTick',[],...
    'ZGrid','off',...
    'ZTick',[],...
    'FontUnits','points',...
    'FontSize',Text_SubPlot_FontSize);
ReconsturctMask=zeros(Height,Width,3);
ReconsturctMask(:,:,2)=0.3*double(bwmorph(handles.DSegOperator.Config.DetectionConfig.SkeletonNoBranchMask,'dilate'));
FuseImagenMask=imfuse(handles.DSegOperator.Image,ReconsturctMask,'blend','Scaling','joint');
imshow(FuseImagenMask,'Parent',FigAxe1);hold on;
xlabel(FigAxe1,['Frame ',num2str(handles.DSegOperator.Config.FrameNum)]);
title(FigAxe1,'Segmentation results')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SubPlot_Shift_x=SubPlot_SpacingX;    % ʵʼ (ʵͼƬΪ׼)
SubPlot_Shift_y=0;
FigAxe2=axes('Parent',FigHandle,...
    'Units','centimeters',...
    'OuterPosition',[Figure_OuterMargin+SubPlot_Shift_x Figure_OuterMargin+SubPlot_Shift_y SubPlot_Width-Figure_OuterMargin SubPlot_Height-Figure_OuterMargin],...
    'Position',[SubPlot_TextMargin+Figure_OuterMargin+SubPlot_Shift_x SubPlot_TextMargin+Figure_OuterMargin+SubPlot_Shift_y SubPlot_Width-SubPlot_TextMargin-Figure_OuterMargin SubPlot_Height-SubPlot_TextMargin-Figure_OuterMargin],...
    'Box','off',...
    'XGrid','off',...
    'XTick',[],...
    'YGrid','off',...
    'YTick',[],...
    'ZGrid','off',...
    'ZTick',[],...
    'FontUnits','points',...
    'FontSize',Text_SubPlot_FontSize);

Mask=zeros(Height,Width,3);
Mask(:,:,1)=handles.DSegOperator.Config.DetectionConfig.CurrentBackgroundMask;
Mask(:,:,2)=0.3*double(xor(handles.DSegOperator.Config.DetectionConfig.CurrentMask,handles.DSegOperator.Config.DetectionConfig.SkeletonMask));
Mask(:,:,3)=handles.DSegOperator.Config.DetectionConfig.SkeletonMask;

FuseImagenMask=imfuse(handles.DSegOperator.Image,Mask,'blend','Scaling','joint');
imshow(FuseImagenMask,'Parent',FigAxe2);hold on;
xlabel(FigAxe2,'Mixed Masks: R-Background G-Detection B-Skeleton');
function TEXT_SaveAnalysisFileName_Callback(hObject, eventdata, handles)
Filestring=get(hObject,'String');
if(isempty(Filestring))
    set(hObject,'String',num2str(handles.DSegOperator.Config.OutputConfig.SavingFileName));
    guidata(hObject, handles);
    return
end
handles.DSegOperator.Config.OutputConfig.SavingFileName=Filestring;
function TEXT_SaveAnalysisFileName_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
% Info/Instructions
function UpdateInfo(handles,Message)
delete(get(handles.Axes_ProcessBar,'Child'));
text(0.5, 0.5,Message, ...
    'HorizontalAlignment', 'center', ...
    'Parent',handles.Axes_ProcessBar,...
    'FontUnits', 'Normalized', ...
    'FontSize', 0.7 );
guidata(handles.Axes_ProcessBar, handles);
pause(0.1);
function UpdateInfoColor(handles,Message,Color)
delete(get(handles.Axes_ProcessBar,'Child'));
text(0.5, 0.5,Message, ...
    'HorizontalAlignment', 'center', ...
    'Parent',handles.Axes_ProcessBar,...
    'FontUnits', 'Normalized', ...
    'FontSize', 0.7,...
    'BackgroundColor','k',...
    'Color',Color);
guidata(handles.Axes_ProcessBar, handles);
pause(0.1);
% Memu functions-----------------------------------------------------------
function Menu_Postprocessing_Callback(hObject, eventdata, handles)
function Menu_LoadData_Callback(hObject, eventdata, handles)
function Postprocessing_objectProperties_Callback(hObject, eventdata, handles)
PostAnalysis(hObject);
function CreateVideo_DiftCorrection_Callback(hObject, eventdata, handles)
DriftCorrection(hObject)
% -----------------------------------------------------------
function DebugVerificationButtom_Callback(hObject, eventdata, handles)
% Read and write data
function WriteShape(handles)
Path=handles.DSegOperator.Config.OutputConfig.PathDetection;
Name=strcat(handles.DSegOperator.Config.OutputConfig.SavingFileName,num2str(handles.DSegOperator.Detection(handles.DSegOperator.Config.DetectionConfig.Current.ID).Id,'%05.0f'),'.mat');
files = dir(strcat(Path,Name));
if(isempty(files))
        mkdir(Path)
        Config.System=handles.DSegOperator.Config.System;
        Config.Resize=handles.DSegOperator.Config.PreProcessConfig.Resize.Num;
        Config.ROI=handles.DSegOperator.Config.PreProcessConfig.ROI;
        Config.Width=size(handles.DSegOperator.Image,1);
        Config.Height=size(handles.DSegOperator.Image,2);
        if(isempty(Config.ROI))
            Config.ROI=[0 0 Config.Height Config.Width];
        end
        Config.Offset=[round(Config.ROI(1)/Config.Resize) round(Config.ROI(2)/Config.Resize)];
        PixelIDs=handles.DSegOperator.Detection(handles.DSegOperator.Config.DetectionConfig.Current.ID).PixelIDs;
        ResultsData=[];
        save(strcat(Path,Name),'ResultsData','Config','PixelIDs');
else
    if(~isempty(handles.DSegOperator.Results))
        m = matfile(strcat(Path,Name),'Writable',true);
        m.PixelIDs=handles.DSegOperator.Detection(handles.DSegOperator.Config.DetectionConfig.Current.ID).PixelIDs;
    end
end
function WriteDetection(handles)
Path=handles.DSegOperator.Config.OutputConfig.PathDetection;
Name=strcat(handles.DSegOperator.Config.OutputConfig.SavingFileName,num2str(handles.DSegOperator.Detection(handles.DSegOperator.Config.DetectionConfig.Current.ID).Id,'%05.0f'),'.mat');
files = dir(strcat(Path,Name));
if(isempty(files))
    mkdir(Path)
    if(~isempty(handles.DSegOperator.Results.Data))
        ResultsData=handles.DSegOperator.Results.Data;
        Config.System=handles.DSegOperator.Config.System;
        Config.Resize=handles.DSegOperator.Config.PreProcessConfig.Resize.Num;
        Config.ROI=handles.DSegOperator.Config.PreProcessConfig.ROI;
        Config.Width=size(handles.DSegOperator.Image,1);
        Config.Height=size(handles.DSegOperator.Image,2);
        if(isempty(Config.ROI))
            Config.ROI=[0 0 Config.Height Config.Width];
        end
        Config.Offset=[round(Config.ROI(1)/Config.Resize) round(Config.ROI(2)/Config.Resize)];
        save(strcat(Path,Name),'ResultsData','Config');
    end
else
    if(~isempty(handles.DSegOperator.Results))
        m = matfile(strcat(Path,Name),'Writable',true);
        m.ResultsData = [m.ResultsData;handles.DSegOperator.Results.Data];
    end
end
function ReadDatafromFile(handles)
files = dir('Saved Data/*.mat');
image=handles.DSegOperator.Image;
image3d=repmat(image,[1 1 3]);
demo_image3all=zeros(size(image3d));
for i=1:length(files)
    demo_image=zeros(size(image));
    color=rand(1,3);
    matdata=load(strcat('Saved Data/',files(i).name));
    [idx,idy]=ind2sub(matdata.SizeIm,matdata.PixelIDs);
    for j=1:length(idx)
        demo_image(idx(j),idy(j))=1;
    end
    demo_image=bwmorph(demo_image,'dilate');
    demo_image3=cat(3, color(1).*demo_image, color(2).*demo_image,color(3).*demo_image);
    demo_image3all=demo_image3all+demo_image3;
end
image3d=imfuse(demo_image3all,image3d,'blend','Scaling','joint');
figure;imshow(handles.image3d)
function Data=ReadDetection(handles)
Path=handles.DSegOperator.Config.OutputConfig.PathDetection;
Name=strcat(handles.DSegOperator.Config.OutputConfig.SavingFileName,num2str(handles.DSegOperator.Detection(handles.DSegOperator.Config.DetectionConfig.Current.ID).Id,'%05.0f'),'.mat');
files = dir(strcat(Path,Name));
if(isempty(files))
    Data=[];
else
    Datatemp=load(strcat(Path,Name));
    if(isfield(Datatemp,'ResultsData'))
        Data=Datatemp.ResultsData;
    else
        Data=[];
    end
end

function handles=DeteleFile(handles)
Path=handles.DSegOperator.Config.OutputConfig.PathDetection;
Name=strcat(handles.DSegOperator.Config.OutputConfig.SavingFileName,num2str(handles.DSegOperator.Detection(handles.DSegOperator.Config.DetectionConfig.Current.ID).Id,'%05.0f'),'.mat');
files = dir(strcat(Path,Name));
if(isempty(files))
    UpdateInfo(handles,'Could not find the file to delete.');
else
    try
        delete(strcat(Path,Name));
    catch
        UpdateInfo(handles,'Could not delete data file.');
    end
end
% Set parameters
function TEXT_System_PixelSpacing_Callback(hObject, eventdata, handles)
Numstring=get(hObject,'String');
if(isempty(Numstring))
    set(hObject,'String',num2str(handles.DSegOperator.Config.System.PixelSpacing*1e9,'%10.3f'));
    guidata(hObject, handles);
    return
end
[Pixelspacing, status] = str2num(Numstring);
if(status==0)
    set(hObject,'String',num2str(handles.DSegOperator.Config.System.PixelSpacing*1e9,'%10.3f'));
    guidata(hObject, handles);
    return
end
Pixelspacing=Pixelspacing/1e9;
if(Pixelspacing>0)
    handles.DSegOperator.Config.System.PixelSpacing=Pixelspacing;
else
    set(hObject,'String',num2str(handles.DSegOperator.Config.System.PixelSpacing*1e9,'%10.3f'));
    return
end
set(hObject,'String',num2str(handles.DSegOperator.Config.System.PixelSpacing*1e9,'%10.3f'));
handles=UpdateObjectLengthRange(handles);
guidata(hObject, handles);
function TEXT_System_PixelSpacing_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function TEXT_System_TimeInterval_Callback(hObject, eventdata, handles)
Numstring=get(hObject,'String');
if(isempty(Numstring))
    set(hObject,'String',num2str(handles.DSegOperator.Config.System.TimeInterval,'%10.1f'));
    guidata(hObject, handles);
    return
end
[TimeInterval, status] = str2num(Numstring);
if(status==0)
    set(hObject,'String',num2str(handles.DSegOperator.Config.System.TimeInterval,'%10.1f'));
    guidata(hObject, handles);
    return
end
if(TimeInterval>0)
    handles.DSegOperator.Config.System.TimeInterval=TimeInterval;
else
    set(hObject,'String',num2str(handles.DSegOperator.Config.System.TimeInterval,'%10.1f'));
    return
end
set(hObject,'String',num2str(handles.DSegOperator.Config.System.TimeInterval,'%10.1f'));
guidata(hObject, handles);
function TEXT_System_TimeInterval_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
%% Selected object list
function handles=updateListAndProcess(handles,Selected_value)
% Get data to present
handles.DSegOperator.Config.DetectionConfig.Current.ID=Selected_value;
% Get seed point to evolve
handles.DSegOperator.Config.DetectionConfig.Method.SEED=handles.DSegOperator.Detection(Selected_value).SeedPoints;
% Get Starting frame
if(handles.DSegOperator.Detection(Selected_value).CurrentFrame==0)
   return; 
end
startingframe=handles.DSegOperator.Detection(Selected_value).CurrentFrame;
handles.DSegOperator.Config.AVIobj.CurrentTime = double(startingframe-1)/handles.DSegOperator.Config.AVIobj.FrameRate;
% Show detection result
if(handles.DSegOperator.Config.AVIobj.CurrentTime<handles.DSegOperator.Config.AVIobj.Duration)
    if(~isempty(handles.DSegOperator.Config.AVIobj.Name))
        handles.DSegOperator.Config.Frame=readFrame(handles.DSegOperator.Config.AVIobj);
    end
end
handles.DSegOperator.Preprocess(handles.DSegOperator.Config.Frame);
% Update thresholding
handles.DSegOperator.Config.DetectionConfig.Method.Name='';
handles.DSegOperator.Detect(handles.DSegOperator.Image,0);
handles.DSegOperator.Config.DetectionConfig.Method.Name='SingleCellDetection';
% Update detection
handles=updateDetectionMask(handles);

% Update GUI list
updateSelectedObjectList(handles);
% Update GUI slider
set(handles.Slider_FrameNumber,'Value',handles.DSegOperator.Config.AVIobj.CurrentTime*handles.DSegOperator.Config.AVIobj.FrameRate);
set(handles.TEXT_CurrentObjectID,'String',num2str(handles.DSegOperator.Detection(handles.DSegOperator.Config.DetectionConfig.Current.ID).Id))
handles=UpdateFrameNum(handles);
Present_ImageTemplate(handles);
function handles=updateSelectedObjectList(handles)
if(~isempty(handles.DSegOperator.Detection))
    DataTemp=handles.DSegOperator.Detection;
else
    set(handles.List_SelectedObjects,'String',{});
    set(handles.List_SelectedObjects,'Value',0);
    return
end
DataSize=size(handles.DSegOperator.Detection,2);
DataString=cell(DataSize,1);
cf=handles.DSegOperator.Config.System.PixelSpacing*1e6/handles.DSegOperator.Config.PreProcessConfig.Resize.Num;
Current.ID=0;
for i=1:DataSize
    if(handles.DSegOperator.Config.DetectionConfig.Current.ID==i)
        Current.ID=i;
    end
    DataString{i}=['ID: ' num2str(DataTemp(i).Id,'%05.0f') ...
        '    ',', Width: ' num2str(DataTemp(i).Width*cf,'%10.4f') ...
        '    ',', Length: ' num2str(DataTemp(i).Length*cf,'%10.4f') ...
        '    ',', Frames: ' num2str(DataTemp(i).StartFrame,'%05.0f') '-' num2str(DataTemp(i).EndFrame,'%05.0f') ...
        '    ',', Current :' num2str(DataTemp(i).CurrentFrame,'%05.0f') ...
        '    ',', Complete(%) :' num2str(100*abs((DataTemp(i).CurrentFrame-DataTemp(i).StartFrame)/(DataTemp(i).EndFrame-DataTemp(i).StartFrame+1)),'%03.1f')];
    
       % '    ',', A: ' num2str(DataTemp(i).Area*cf*cf,'%10.4f') ...
       % '    ',', O: ' num2str(DataTemp(i).Orientation,'%10.2f') ...
       % '    ',', G: ' num2str(DataTemp(i).Growingspeed*cf*cf,'%10.4f') ...
end
set(handles.List_SelectedObjects,'String',DataString);
set(handles.List_SelectedObjects,'Value',Current.ID);
function List_SelectedObjects_Callback(hObject, eventdata, handles)
if(~isempty(handles.DSegOperator.Detection))
    Selected_value=get(hObject,'Value');
    handles=updateListAndProcess(handles,Selected_value);
    handles=UpdateAnalysisResultOnlyRead(handles);
end
function List_SelectedObjects_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
% selection changes
function Botton_AddobjecttoList_Callback(hObject, eventdata, handles)
% Allow new data
handles.DSegOperator.Config.DetectionConfig.Add=1;

% Select from display
[x_all, y_all]=GetPointsFromImage(handles);

% Init Parameters
startingframe=handles.DSegOperator.Config.FrameNum;
handles.DSegOperator.Config.AVIobj.CurrentTime = double(startingframe-1)/handles.DSegOperator.Config.AVIobj.FrameRate;
% Init seed
handles=initSelectionParameters(handles);
for i_xy=1:length(x_all)
    % Init object position
    handles.DSegOperator.Config.DetectionConfig.Method.SEED=[x_all(i_xy) y_all(i_xy)];
    handles.DSegOperator.Preprocess(handles.DSegOperator.Config.Frame);
    handles.DSegOperator.Detect(handles.DSegOperator.Image,1);
    if(handles.DSegOperator.Config.DetectionConfig.ValidMask==1)
        handles.DSegOperator.Config.DetectionConfig.Current.ID=length(handles.DSegOperator.Detection);
        handles.DSegOperator.Config.DetectionConfig.Current.ApplyID=handles.DSegOperator.Config.DetectionConfig.Current.ID;
    end
    updateSelectedObjectList(handles);
    % Update Slide
    set(handles.Slider_FrameNumber,'Value',handles.DSegOperator.Config.AVIobj.CurrentTime*handles.DSegOperator.Config.AVIobj.FrameRate+1);
end
if(~isempty(handles.DSegOperator.Detection))
    handles=UpdateAllResults(handles);
    handles=updateButtonDetection(handles,'on');
end
handles.DSegOperator.Config.DetectionConfig.Add=0;

guidata(hObject, handles);
function Botton_DeleteobjectfromList_Callback(hObject, eventdata, handles)
Selected_value=get(handles.List_SelectedObjects,'Value');
if(Selected_value~=0 && ~isempty(handles.DSegOperator.Detection))
    % Remove from disk
    handles.DSegOperator.Config.DetectionConfig.Current.ID=Selected_value;
    handles=DeteleFile(handles);
    % Remove from memory
    handles.DSegOperator.DeleteDetection(Selected_value);
    % Update list
    DataSize=size(handles.DSegOperator.Detection,2);
    if(DataSize~=0)
        if(Selected_value>DataSize)
            Selected_value=DataSize;
            handles.DSegOperator.Config.DetectionConfig.Current.ID=Selected_value;
        end
        handles=updateListAndProcess(handles,Selected_value);
        set(handles.List_SelectedObjects,'Value',Selected_value);
        handles.DSegOperator.Config.DetectionConfig.Current.ApplyID=Selected_value;
    else
        handles=ClearALLSegmentationResults(handles);
        % Update Image
        handles=GUI_DisableButtons(handles);
        handles=UpdatePreProcessNDetectionNoSeedPoint(handles);
        handles=UpdateButtonsLoadVideo(handles);
    end
end
handles=UpdateAnalysisResultOnlyRead(handles);
guidata(hObject, handles);
function Botton_ClearList_Callback(hObject, eventdata, handles)
handles=ClearALLSegmentationResults(handles);
% Update Image
handles=UpdatePreProcessNDetectionNoSeedPoint(handles);
handles=UpdateAnalysisResultOnlyRead(handles);
guidata(hObject, handles);
% End frame update
function TEXT_SelectEndFrames_Callback(hObject, eventdata, handles)
Numstring=get(hObject,'String');
if(isempty(Numstring))
    set(hObject,'String',num2str(handles.DSegOperator.Config.ProcessEndFrame));
    guidata(hObject, handles);
    return
end
[PFrameEnd, status] = str2num(Numstring);
if(status==0)
    set(hObject,'String',num2str(handles.DSegOperator.Config.ProcessEndFrame));
    guidata(hObject, handles);
    return
end
if(PFrameEnd>handles.DSegOperator.Config.FrameNum && PFrameEnd<=round(handles.DSegOperator.Config.AVIobj.FrameRate*handles.DSegOperator.Config.AVIobj.Duration))
    handles.DSegOperator.Config.ProcessEndFrame=PFrameEnd;
    handles.DSegOperator.Config.ProcessFrames=PFrameEnd-handles.DSegOperator.Config.FrameNum+1;
else
    set(hObject,'String',num2str(handles.DSegOperator.Config.ProcessEndFrame));
    return
end
set(hObject,'String',num2str(handles.DSegOperator.Config.ProcessEndFrame));
handles=updateProcessFrame(handles);
guidata(hObject, handles);
function TEXT_SelectEndFrames_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function handles=updateProcessEndFrame(handles)
handles.DSegOperator.Config.ProcessEndFrame=min(handles.DSegOperator.Config.FrameNum+handles.DSegOperator.Config.ProcessFrames-1,round(handles.DSegOperator.Config.AVIobj.FrameRate*handles.DSegOperator.Config.AVIobj.Duration));
set(handles.TEXT_SelectEndFrames,'String',num2str(handles.DSegOperator.Config.ProcessEndFrame));
% Update frame number
function handles=updateProcessFrame(handles)
handles.DSegOperator.Config.ProcessFrame=max(0,round(handles.DSegOperator.Config.ProcessEndFrame-handles.DSegOperator.Config.FrameNum+1));
set(handles.TEXT_SelectNumofFrames,'String',num2str(handles.DSegOperator.Config.ProcessFrame));
% Object length range Min Max --'MaximumAxisLength'
function TEXT_SelectObjectMinSize_Callback(hObject, eventdata, handles)
convf2=handles.DSegOperator.Config.System.PixelSpacing*1e6*handles.DSegOperator.Config.PreProcessConfig.Resize.Num;
Numstring=get(hObject,'String');
if(isempty(Numstring))
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.MinSize*convf2,'%10.3f'));
    guidata(hObject, handles);
    return
end
[MinSize, status] = str2num(Numstring);
if(status==0)
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.MinSize*convf2,'%10.3f'));
    guidata(hObject, handles);
    return
end
PixelSize=MinSize/convf2;
if(PixelSize>=0 && PixelSize<handles.DSegOperator.Config.DetectionConfig.MaxSize)
    handles.DSegOperator.Config.DetectionConfig.MinSize=max(1,round(PixelSize));
else
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.MinSize*convf2,'%10.3f'));
    return
end
set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.MinSize*convf2,'%10.3f'));
guidata(hObject, handles);
function TEXT_SelectObjectMinSize_CreateFcn(hObject, eventdata, handles)
% hObject    handle to TEXT_SelectObjectMinSize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function TEXT_SelectObjectMaxSize_Callback(hObject, eventdata, handles)
convf2=handles.DSegOperator.Config.System.PixelSpacing*1e6*handles.DSegOperator.Config.PreProcessConfig.Resize.Num;
Numstring=get(hObject,'String');
if(isempty(Numstring))
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.MaxSize*convf2,'%10.3f'));
    guidata(hObject, handles);
    return
end
[MaxSize, status] = str2num(Numstring);
if(status==0)
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.MaxSize*convf2,'%10.3f'));
    guidata(hObject, handles);
    return
end
PixelSize=MaxSize/convf2;
if(PixelSize>1 && PixelSize>handles.DSegOperator.Config.DetectionConfig.MinSize)
    handles.DSegOperator.Config.DetectionConfig.MaxSize=round(PixelSize);
else
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.MaxSize*convf2,'%10.3f'));
    return
end
set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.MaxSize*convf2,'%10.3f'));
guidata(hObject, handles);
function TEXT_SelectObjectMaxSize_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
% Update object length range
function handles=UpdateObjectLengthRange(handles)
convf=handles.DSegOperator.Config.System.PixelSpacing*1e6*handles.DSegOperator.Config.PreProcessConfig.Resize.Num;
set(handles.TEXT_SelectObjectMinSize,'String',num2str(handles.DSegOperator.Config.DetectionConfig.MinSize*convf,'%10.3f'));
set(handles.TEXT_SelectObjectMaxSize,'String',num2str(handles.DSegOperator.Config.DetectionConfig.MaxSize*convf,'%10.3f'));
% Show selections objects
function Button_SaveResults_Callback(hObject, eventdata, handles)
UpdateInfo(handles,'Please wait...');
guidata(hObject, handles);
handles=UpdateAllResults(handles);
UpdateInfo(handles,'Done.');
guidata(hObject, handles);
function handles=UpdateAllResults(handles)
NumofDetection=length(handles.DSegOperator.Detection);
[sx,sy,~]=size(handles.DSegOperator.Image);
image=handles.DSegOperator.Image;
image3d=repmat(image,[1 1 3]);
demo_image3all=zeros(size(image3d));
for i=1:NumofDetection
    handles.DSegOperator.Config.DetectionConfig.Current.ID=i;
    
    demo_image=zeros(size(image));
    color=rand(1,3);
    matdata=handles.DSegOperator.Detection(i).PixelIDs;
    [idx,idy]=ind2sub([sx sy],matdata);
    for j=1:length(idx)
        demo_image(idx(j),idy(j))=1;
    end
    %demo_image=bwmorph(demo_image,'dilate',max(1,round((handles.DSegOperator.Detection(i).Width-1)/2)));
    demo_image3=cat(3, color(1).*demo_image, color(2).*demo_image,color(3).*demo_image);
    demo_image3all=demo_image3all+demo_image3;
    WriteShape(handles);
end
image3d=imfuse(demo_image3all,image3d,'blend','Scaling','joint');
f_handle=figure(handles.figure_CGTracking);
set(f_handle,'CurrentAxes',handles.MainAxes_FrameDisplay)
imshow(image3d);
imwrite(image,strcat(handles.DSegOperator.Config.OutputConfig.PathDetection,'/Template.png'),'PNG');
imwrite(image3d,strcat(handles.DSegOperator.Config.OutputConfig.PathDetection,'/Results.png'),'PNG');
% Level set -split condition
function TEXT_LevelSetBranchSplit_Callback(hObject, eventdata, handles)
Numstring=get(hObject,'String');
if(isempty(Numstring))
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.LEVELSET.MinSplitSize,'%10.0f'));
    guidata(hObject, handles);
    return
end
[LevelsplitSize, status] = str2num(Numstring);
if(status==0)
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.LEVELSET.MinSplitSize,'%10.0f'));
    guidata(hObject, handles);
    return
end
if(LevelsplitSize>=0)
    handles.DSegOperator.Config.DetectionConfig.LEVELSET.MinSplitSize=round(LevelsplitSize);
end
set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.LEVELSET.MinSplitSize,'%10.0f'));
guidata(hObject, handles);
function TEXT_LevelSetBranchSplit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to TEXT_LevelSetBranchSplit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
% Object Selection Auto-Manual
function Buttom_AutoSelection_Callback(hObject, eventdata, handles)
value=get(hObject,'Value');
if(value==1)
    handles.DSegOperator.Config.DetectionConfig.AutoSelect=1;
end
guidata(hObject, handles);
function Button_SelectFromImage_Callback(hObject, eventdata, handles)
value=get(hObject,'Value');
if(value==1)
    handles.DSegOperator.Config.DetectionConfig.AutoSelect=0;
end
guidata(hObject, handles);
% Background update parameters
function TEXT_BackgroundThreholdLevel_Callback(hObject, eventdata, handles)
Numstring=get(hObject,'String');
if(isempty(Numstring))
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.BackgroundThreholdLevel,'%10.2f'));
    guidata(hObject, handles);
    return
end
[Bthresh, status] = str2num(Numstring);
if(status==0)
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.BackgroundThreholdLevel,'%10.2f'));
    guidata(hObject, handles);
    return
end
if(Bthresh>=0 && Bthresh<=1)
    handles.DSegOperator.Config.DetectionConfig.BackgroundThreholdLevel=Bthresh;
end
set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.BackgroundThreholdLevel,'%10.2f'));
guidata(hObject, handles);
function TEXT_BackgroundThreholdLevel_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function TEXT_CurrentBackgroundMaskRatio_Callback(hObject, eventdata, handles)
Numstring=get(hObject,'String');
if(isempty(Numstring))
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.CurrentBackgroundMaskRatio,'%10.2f'));
    guidata(hObject, handles);
    return
end
[BRatio, status] = str2num(Numstring);
if(status==0)
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.CurrentBackgroundMaskRatio,'%10.2f'));
    guidata(hObject, handles);
    return
end
if(BRatio>=0.5 && BRatio<1)
    handles.DSegOperator.Config.DetectionConfig.CurrentBackgroundMaskRatio=BRatio;
end
set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.CurrentBackgroundMaskRatio,'%10.2f'));
guidata(hObject, handles);
function TEXT_CurrentBackgroundMaskRatio_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function TEXT_BackgroundThreholdWeight_Callback(hObject, eventdata, handles)
Numstring=get(hObject,'String');
if(isempty(Numstring))
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.NoBranchWeightMagnitude,'%10.2f'));
    guidata(hObject, handles);
    return
end
[BRatio, status] = str2num(Numstring);
if(status==0)
    set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.NoBranchWeightMagnitude,'%10.2f'));
    guidata(hObject, handles);
    return
end
if(BRatio>=0 && BRatio<=100)
    handles.DSegOperator.Config.DetectionConfig.NoBranchWeightMagnitude=BRatio;
end
set(hObject,'String',num2str(handles.DSegOperator.Config.DetectionConfig.NoBranchWeightMagnitude,'%10.2f'));
guidata(hObject, handles);
function TEXT_BackgroundThreholdWeight_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function TEXT_CurrentObjectID_CreateFcn(hObject, eventdata, handles)
% additional functions
function pushbutton_SelectObject_Callback(hObject, eventdata, handles)
UpdateInfo(handles,'Please wait...');
guidata(hObject, handles);
NumofDetection=length(handles.DSegOperator.Detection);
[sx,sy,~]=size(handles.DSegOperator.Image);
image=handles.DSegOperator.Image;
image3d=repmat(image,[1 1 3]);
ObjectIDimage=zeros(size(image));
demo_image3all=zeros(size(image3d));
for i=1:NumofDetection
    demo_image=zeros(size(image));
    color=rand(1,3);
    matdata=handles.DSegOperator.Detection(i).PixelIDs;
    [idx,idy]=ind2sub([sx sy],matdata);
    for j=1:length(idx)
        demo_image(idx(j),idy(j))=1;
        ObjectIDimage(idx(j),idy(j))=i;
    end
    demo_image=bwmorph(demo_image,'dilate',max(1,round((handles.DSegOperator.Detection(i).Width-1)/2)));
    demo_image3=cat(3, color(1).*demo_image, color(2).*demo_image,color(3).*demo_image);
    demo_image3all=demo_image3all+demo_image3;
end
image3d=imfuse(demo_image3all,image3d,'blend','Scaling','joint');
f_handle=figure(handles.figure_CGTracking);
set(f_handle,'CurrentAxes',handles.MainAxes_FrameDisplay)
imshow(image3d);
UpdateInfo(handles,'Double click on an object.');
[x_all, y_all]=GetPointsOnly(handles,handles.MainAxes_FrameDisplay);
ObjectID=zeros(1,length(x_all));
for i_xy=1:length(x_all)
    ObjectID(i_xy)=ObjectIDimage(round(x_all(i_xy)),round(y_all(i_xy)));
end

ObjectID(ObjectID==0)=[];
ObjectID=unique(ObjectID);

if(length(ObjectID)<1)
    UpdateInfo(handles,'Could not find any objects.');
   return 
end
handles=updateListAndProcess(handles,ObjectID(1));
handles=UpdateAnalysisResultOnlyRead(handles);
UpdateInfo(handles,'Done.');
guidata(hObject, handles);
function pushbutton_disconnect_Callback(hObject, eventdata, handles)
UpdateInfo(handles,'Please wait...');
guidata(hObject, handles);
NumofDetection=length(handles.DSegOperator.Detection);
[sx,sy,~]=size(handles.DSegOperator.Image);
image=handles.DSegOperator.Image;
image3d=repmat(image,[1 1 3]);
ObjectIDimage=zeros(size(image));
demo_image3all=zeros(size(image3d));
for i=1:NumofDetection
    demo_image=zeros(size(image));
    color=rand(1,3);
    matdata=handles.DSegOperator.Detection(i).PixelIDs;
    [idx,idy]=ind2sub([sx sy],matdata);
    for j=1:length(idx)
        demo_image(idx(j),idy(j))=1;
        ObjectIDimage(idx(j),idy(j))=i;
    end
    demo_image=bwmorph(demo_image,'dilate',max(1,round((handles.DSegOperator.Detection(i).Width-1)/2)));
    demo_image3=cat(3, color(1).*demo_image, color(2).*demo_image,color(3).*demo_image);
    demo_image3all=demo_image3all+demo_image3;
end
image3d=imfuse(demo_image3all,image3d,'blend','Scaling','joint');
f_handle=figure(handles.figure_CGTracking);
set(f_handle,'CurrentAxes',handles.MainAxes_FrameDisplay)
imshow(image3d);
UpdateInfoColor(handles,'Click on different objects and double click to finish.',[0 1 0]);
[x_all, y_all]=GetPointsOnly(handles,handles.MainAxes_FrameDisplay);

ObjectID=zeros(1,length(x_all));
for i_xy=1:length(x_all)
    ObjectID(i_xy)=ObjectIDimage(round(x_all(i_xy)),round(y_all(i_xy)));
end

ObjectID(ObjectID==0)=[];
ObjectID=unique(ObjectID);

if(length(ObjectID)<1)
    UpdateInfoColor(handles,'Could not find any objects.',[1 0 0]);
   return 
end

TemplateImage=false(size(image));
single_object_id=1;
for i_xy=1:length(ObjectID)
    matdata=handles.DSegOperator.Detection(ObjectID(single_object_id)).PixelIDs;
    [idx,idy]=ind2sub([sx sy],matdata);
    for j=1:length(idx)
        TemplateImage(idx(j),idy(j))=true;
    end
    TemplateImageShow=bwmorph(TemplateImage,'dilate',max(1,round((handles.DSegOperator.Detection(ObjectID(single_object_id)).Width-1)/2)));
    set(handles.List_SelectedObjects,'Value',ObjectID(single_object_id));
end

set(f_handle,'CurrentAxes',handles.MainAxes_FrameDisplay);
imshow(TemplateImageShow);
UpdateInfoColor(handles,'Click on pixels to be removed and double click to finish.',[0 1 0]);

[x_all, y_all]=GetPointsOnly(handles,handles.MainAxes_FrameDisplay);

for i_xy=1:length(x_all)
    TemplateImage(round(x_all(i_xy)),round(y_all(i_xy)))=false;
end
Regions=regionprops(TemplateImage,'Area','PixelIdxList','Orientation');
Max_Area=0;
Max_id=0;
for i=1:length(Regions)
    if(Regions(i).Area>Max_Area)
        Max_id=i;
        Max_Area=Regions(i).Area;
    end
end
% Update detections
if(Max_id~=0)
     Width=min(Max_Area,handles.DSegOperator.Detection(ObjectID(single_object_id)).Width);
     Growingspeed_Pre=handles.DSegOperator.Detection(ObjectID(single_object_id)).Growingspeed;
                handles.DSegOperator.SetDetection(ObjectID(single_object_id),...
                    'Width',Width);
                handles.DSegOperator.SetDetection(ObjectID(single_object_id),...
                    'PixelIDs',Regions(Max_id).PixelIdxList);
                handles.DSegOperator.SetDetection(ObjectID(single_object_id),...
                    'Length',Max_Area+Width);
                handles.DSegOperator.SetDetection(ObjectID(single_object_id),...
                    'Area',Width*(Max_Area+Width));
                handles.DSegOperator.SetDetection(ObjectID(single_object_id),...
                    'Growingspeed',Width*Max_Area-Growingspeed_Pre);
                handles.DSegOperator.SetDetection(ObjectID(single_object_id),...
                    'Orientation',Regions(Max_id).Orientation);
                handles.DSegOperator.SetDetection(ObjectID(single_object_id),...
                    'SeedPoints',Regions(Max_id).PixelIdxList);
end
TemplateImage=false(size(image));
matdata=handles.DSegOperator.Detection(ObjectID(single_object_id)).PixelIDs;
[idx,idy]=ind2sub([sx sy],matdata);
for j=1:length(idx)
        TemplateImage(idx(j),idy(j))=true;
end
TemplateImageShow=bwmorph(TemplateImage,'dilate',max(1,round((handles.DSegOperator.Detection(ObjectID(single_object_id)).Width-1)/2)));    
set(f_handle,'CurrentAxes',handles.MainAxes_FrameDisplay);
imshow(TemplateImageShow);
UpdateInfo(handles,'Updating...Please wait...');

handles=updateSelectedObjectList(handles);
set(handles.List_SelectedObjects,'Value',ObjectID(single_object_id));

handles.DSegOperator.Config.DetectionConfig.Current.ID=ObjectID(single_object_id);
handles.DSegOperator.Config.DetectionConfig.Current.ApplyID=ObjectID(single_object_id);

handles.DSegOperator.Config.DetectionConfig.SkeletonNoBranchMask=TemplateImage;
handles.DSegOperator.Analyze(handles.DSegOperator.Config.FrameNum);

handles=UpdateAnalysisResult(handles);
WriteShape(handles);

UpdateInfoColor(handles,'Done.',[0 1 0]);
guidata(hObject, handles);
function pushbutton_connect_Callback(hObject, eventdata, handles)
UpdateInfo(handles,'Please wait...');
guidata(hObject, handles);
NumofDetection=length(handles.DSegOperator.Detection);
[sx,sy,~]=size(handles.DSegOperator.Image);
image=handles.DSegOperator.Image;
image3d=repmat(image,[1 1 3]);
ObjectIDimage=zeros(size(image));
demo_image3all=zeros(size(image3d));
for i=1:NumofDetection
    demo_image=zeros(size(image));
    color=rand(1,3);
    matdata=handles.DSegOperator.Detection(i).PixelIDs;
    [idx,idy]=ind2sub([sx sy],matdata);
    for j=1:length(idx)
        demo_image(idx(j),idy(j))=1;
        ObjectIDimage(idx(j),idy(j))=i;
    end
    demo_image=bwmorph(demo_image,'dilate',max(1,round((handles.DSegOperator.Detection(i).Width-1)/2)));
    demo_image3=cat(3, color(1).*demo_image, color(2).*demo_image,color(3).*demo_image);
    demo_image3all=demo_image3all+demo_image3;
end
image3d=imfuse(demo_image3all,image3d,'blend','Scaling','joint');
f_handle=figure(handles.figure_CGTracking);
set(f_handle,'CurrentAxes',handles.MainAxes_FrameDisplay);
imshow(image3d);
UpdateInfoColor(handles,'Click on two objects and double click .',[0 1 0]);
[x_all, y_all]=GetPointsOnly(handles,handles.MainAxes_FrameDisplay);
ObjectID=zeros(1,length(x_all));
for i_xy=1:length(x_all)
    ObjectID(i_xy)=ObjectIDimage(round(x_all(i_xy)),round(y_all(i_xy)));
end

ObjectID(ObjectID==0)=[];
ObjectID=unique(ObjectID);

if(length(ObjectID)~=2)
    UpdateInfoColor(handles,'Two objects should be selected.',[0 1 0]);
   return 
end

ObjectImage1=false(size(image));
matdata=handles.DSegOperator.Detection(ObjectID(1)).PixelIDs;
[idx,idy]=ind2sub([sx sy],matdata);
for j=1:length(idx)
    ObjectImage1(idx(j),idy(j))=true;
end

ObjectImage2=false(size(image));
matdata=handles.DSegOperator.Detection(ObjectID(2)).PixelIDs;
[idx,idy]=ind2sub([sx sy],matdata);
for j=1:length(idx)
    ObjectImage2(idx(j),idy(j))=true;
end
Endpoints1=bwmorph(ObjectImage1,'Endpoints');
Endpoints1d=bwmorph(Endpoints1,'dilate',2);
Endpoints2=bwmorph(ObjectImage2,'Endpoints');
Endpoints2d=bwmorph(Endpoints2,'dilate',2);
ObjectImage=0.5*double(or(ObjectImage1,ObjectImage2));
ObjectImageColor=repmat(ObjectImage,[1 1 3]);
ObjectImageColor(:,:,2)=double(Endpoints1d)+ObjectImage;
ObjectImageColor(:,:,3)=double(Endpoints2d)+ObjectImage;
set(f_handle,'CurrentAxes',handles.MainAxes_FrameDisplay)
imshow(ObjectImageColor);
UpdateInfo(handles,'Click on endpoints to connect two objects. Double click to finish.');

[x_all, y_all]=GetPointsOnly(handles,handles.MainAxes_FrameDisplay);
TemplateImage=false(size(image));
for i_xy=1:length(x_all)
    TemplateImage(round(x_all(i_xy)),round(y_all(i_xy)))=true;
end
TemplateImage=bwmorph(TemplateImage,'dilate',3);
selectedPoints=find(TemplateImage==1);

P1=[];P2=[];
for i_p=1:length(selectedPoints)
    if(Endpoints1(selectedPoints(i_p))==1)
        P1=selectedPoints(i_p);
    end
    
    if(Endpoints2(selectedPoints(i_p))==1)
        P2=selectedPoints(i_p);
    end
end
if(isempty(P1) || isempty(P2))
   UpdateInfo(handles,'Cannot find selected endpoints.'); 
   return 
end

TemplateImage1=false(size(image));
TemplateImage2=false(size(image));
TemplateImage1(P1)=true;
TemplateImage2(P2)=true;
distTrans1= bwdist(TemplateImage1, 'quasi-euclidean');
distTrans2= bwdist(TemplateImage2, 'quasi-euclidean');
D = distTrans1 + distTrans2;
D = round(D * 32) / 32;

Short_paths=imregionalmin(D);
Short_paths = bwmorph(Short_paths, 'thin', inf);

ConnectedImage=(ObjectImage1+ObjectImage2+Short_paths)>0;
Regions=regionprops(ConnectedImage,'Area','PixelIdxList','Orientation');
% Update detections
Width=min(Regions(1).Area,handles.DSegOperator.Detection(ObjectID(1)).Width);
Growingspeed_Pre=handles.DSegOperator.Detection(ObjectID(1)).Growingspeed;
handles.DSegOperator.SetDetection(ObjectID(1),...
    'Width',Width);
handles.DSegOperator.SetDetection(ObjectID(1),...
    'PixelIDs',Regions(1).PixelIdxList);
handles.DSegOperator.SetDetection(ObjectID(1),...
    'Length',Regions(1).Area+Width);
handles.DSegOperator.SetDetection(ObjectID(1),...
    'Area',Width*(Regions(1).Area+Width));
handles.DSegOperator.SetDetection(ObjectID(1),...
    'Growingspeed',Width*Regions(1).Area-Growingspeed_Pre);
handles.DSegOperator.SetDetection(ObjectID(1),...
    'Orientation',Regions(1).Orientation);
handles.DSegOperator.SetDetection(ObjectID(1),...
    'SeedPoints',Regions(1).PixelIdxList);

% Remove the other object
handles.DSegOperator.Config.DetectionConfig.Current.ID=ObjectID(2);
handles=DeteleFile(handles);
handles.DSegOperator.DeleteDetection(ObjectID(2));

ConnectedImage=bwmorph(ConnectedImage,'dilate',max(1,round((handles.DSegOperator.Detection(ObjectID(1)).Width-1)/2)));    
set(f_handle,'CurrentAxes',handles.MainAxes_FrameDisplay);
imshow(ConnectedImage);


handles.DSegOperator.Config.DetectionConfig.Current.ID=ObjectID(1);
handles=updateSelectedObjectList(handles);
set(handles.List_SelectedObjects,'Value',ObjectID(1));

handles.DSegOperator.Config.DetectionConfig.Current.ApplyID=ObjectID(1);

handles.DSegOperator.Config.DetectionConfig.SkeletonNoBranchMask=TemplateImage;
handles.DSegOperator.Analyze(handles.DSegOperator.Config.FrameNum);

handles=UpdateAnalysisResult(handles);
WriteShape(handles);

UpdateInfo(handles,'Done.'); 
guidata(hObject, handles);
function Button_CheckDetection_Callback(hObject, eventdata, handles)
UpdateInfo(handles,'Please wait...');
guidata(hObject, handles);
handles=UpdateAllResults(handles);
UpdateInfo(handles,'Done.');
guidata(hObject, handles);


% --- Executes on button press in StaticObjectParameterSettings.
function StaticObjectParameterSettings_Callback(hObject, eventdata, handles)
CheckValue=get(hObject,'Value');
if(CheckValue==1)
    UpdateInfo(handles,'Parameters are adjusted for static objects');
    % split
    handles.DSegOperator.Config.DetectionConfig.LEVELSET.MinSplitSize=min(1000,round(handles.DSegOperator.Config.DetectionConfig.LEVELSET.MinSplitSize+500));
    set(handles.TEXT_LevelSetBranchSplit,'String',num2str(handles.DSegOperator.Config.DetectionConfig.LEVELSET.MinSplitSize,'%10.0f'));
    % merge
    handles.DSegOperator.Config.DetectionConfig.LEVELSET.MaxMergeSize=min(500,round(handles.DSegOperator.Config.DetectionConfig.LEVELSET.MaxMergeSize+300));
    set(handles.TEXT_LevelSetBranchArea,'String',num2str(handles.DSegOperator.Config.DetectionConfig.LEVELSET.MaxMergeSize,'%10.0f'));

else
    UpdateInfo(handles,'Parameters are adjusted for moving objects');
     % split
    handles.DSegOperator.Config.DetectionConfig.LEVELSET.MinSplitSize=max(10,round(handles.DSegOperator.Config.DetectionConfig.LEVELSET.MinSplitSize-500));
    set(handles.TEXT_LevelSetBranchSplit,'String',num2str(handles.DSegOperator.Config.DetectionConfig.LEVELSET.MinSplitSize,'%10.0f'));
    % merge
    handles.DSegOperator.Config.DetectionConfig.LEVELSET.MaxMergeSize=min(500,round(handles.DSegOperator.Config.DetectionConfig.LEVELSET.MaxMergeSize+300));
    set(handles.TEXT_LevelSetBranchArea,'String',num2str(handles.DSegOperator.Config.DetectionConfig.LEVELSET.MaxMergeSize,'%10.0f'));

end
guidata(hObject, handles);
