function Results=CellLengthAnalysis(BW_img,Config,ResizeNum)
            s_value=1;
            Min_curve_interv=Config.curve_sampling_num;
            BW_img=bwmorph(BW_img,'thin');
            Regional_BW=regionprops(BW_img,'Area','Image');
            Filament_num_BW=length(Regional_BW);
            Filament_num=1;
            % Measurements
            Results.maximum_angle=zeros(1,Filament_num);
            Results.CurveLength_parameter=zeros(1,Filament_num);
            Results.Area=zeros(1,Filament_num);
            Results.Est_PersistanceLength_Cos=zeros(1,Filament_num);
            Results.Est_PersistanceLength_R2=zeros(1,Filament_num);
            BranchImages=bwmorph(BW_img,'branchpoints');
            Results.NumofBranch=Filament_num_BW+sum(BranchImages(:));
            for blob_i=1:Filament_num 
                if(Regional_BW(blob_i).Area>2*Min_curve_interv+1)
                    image_debug=Regional_BW(blob_i).Image;
                    % step.0 Extract discrete points in a polymer 
                    StartPointsBW=bwmorph(Regional_BW(blob_i).Image,'endpoints');
                    [RegionBWRow,RegionBWCol]=size(Regional_BW(blob_i).Image);
                    [StartPointX_ALL,StartPointY_ALL]=ind2sub([RegionBWRow,RegionBWCol],find(StartPointsBW==1));
                    if(isempty(StartPointX_ALL))
                        disp('No endpoints detected')
                        return;
                    end
                    % step.1 Calculated consecutive lines coordinates
                    Curve_SegmentNum=sum(sum(Regional_BW(blob_i).Image==1));
                    Curve_List=zeros(Curve_SegmentNum,2);
                    Curve_List(1,:)=[StartPointX_ALL(1) StartPointY_ALL(1)];
                    StartPointX=StartPointX_ALL(1);
                    StartPointY=StartPointY_ALL(1);
                    for step_s=1:Curve_SegmentNum-1
                        BBox=zeros(1,4);
                        Regional_BW(blob_i).Image(StartPointX,StartPointY)=0;
                        if(StartPointX(1)-1<=0)
                            BBox(1)=1;
                        else
                            BBox(1)=StartPointX(1)-1;
                        end
                        if(StartPointY(1)-1<=0)
                            BBox(2)=1;
                        else
                            BBox(2)=StartPointY(1)-1;
                        end
                        if(StartPointX(1)+1>RegionBWRow)
                            BBox(3)=RegionBWRow;
                        else
                            BBox(3)=StartPointX(1)+1;
                        end
                        if(StartPointY(1)+1>RegionBWCol)
                            BBox(4)=RegionBWCol;
                        else
                            BBox(4)=StartPointY(1)+1;
                        end
                        % Check Neighbouring Pixels
                        flag=0;
                        for ncorr_i=BBox(1):1:BBox(3)
                            for ncorr_j=BBox(2):BBox(4)
                                if(Regional_BW(blob_i).Image(ncorr_i,ncorr_j)==1)
                                    Curve_List(step_s+1,:)=[ncorr_i ncorr_j];
                                    StartPointX = ncorr_i;
                                    StartPointY = ncorr_j;
                                    flag=1;
                                    break;
                                end
                            end
                            if(flag==1)
                                break
                            end
                        end
                    end
                else
                    continue;
                end
                % Calculate the length 
                Maximum_Step=Curve_SegmentNum-1; 
                CurveContourLength=zeros(1,Curve_SegmentNum);
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                % Get accumulated curve 
                length_interval=Config.ChainIntervalLength;
                conversionfactor=Config.ConversionFactor/ResizeNum;
                for step_i=1:Maximum_Step
                    P_midpoint = Curve_List(step_i,:);
                    P_midpoint_next = Curve_List(step_i+1,:);
                    CurveContourLength(step_i+1)=norm(P_midpoint_next-P_midpoint)+CurveContourLength(step_i);
                end
                inc=1;
                R2=zeros(sum(1:Maximum_Step),1);
                MaxR=zeros(1,Maximum_Step-1);
                l_length=zeros(sum(1:Maximum_Step),1);
                for step_i=1:Maximum_Step
                    for step_k=1:Maximum_Step-step_i
                        R2(inc)=norm(Curve_List(step_i+step_k,:)-Curve_List(step_i,:)).^2;
                        MaxR(step_k) = R2(inc)+MaxR(step_k);
                        l_length(inc)=CurveContourLength(step_i+step_k)-CurveContourLength(step_i);
                        inc=inc+1;
                    end
                end
                
                if(Config.PersModel_mse2e==1)
                    loc=max(Min_curve_interv,find(MaxR==max(MaxR),1));
                    R2range=round(CurveContourLength(end));
                    rlist=1:length_interval:R2range;
                    meanR2=zeros(R2range,1); 
                    for k = rlist
                        % Get Indicies 
                        ind = abs(l_length-(k-1))<=length_interval;
                        % calculate Mean within radian:
                        meanR2(k) = mean(R2(ind));
                    end
                    NonNaNloc=~isnan(meanR2);
                    NonNaNloc=and(NonNaNloc,(rlist<loc+250)');
                    
                    rlist_fit=rlist(NonNaNloc)'*conversionfactor*1E6;
                    meanR2_fit=meanR2(NonNaNloc)*(conversionfactor*1E6).^2;
                    
                    %fitEqn='4*a*x-8*a*a*(1-exp(-x/(2*a)))';
                    fitEqn='2*a^2*(exp(-x/(a))-1+x/(a))';
                    [f1,gof] = fit(rlist_fit,meanR2_fit,fitEqn);
                    f1.a=f1.a/s_value;
                    if(Config.Debug==1)
                        figure(10)
                        subplot(2,2,3)
                        plot(rlist*conversionfactor*1E6,meanR2*(conversionfactor*1E6).^2,'.k');hold on;
                        plot(f1,rlist_fit,meanR2_fit);hold off;
                        legend('Averaged data','Averaged data selected','Curve fitting');
                        xlabel('Chain length(um)');
                        ylabel('<R^2> (um^2)');
                        title(['Estimated persistence length: ',num2str(f1.a,'%10.2f\n'),' um'])

                    end
                end
 
                if(Config.PersModel_cos==1)
                    CurveTangent=zeros(Curve_SegmentNum,3);
                    for cont_i=1:Curve_SegmentNum
                        id=cont_i;
                        if(cont_i<=Min_curve_interv)
                            id=Min_curve_interv+1;
                        end
                        if(cont_i>Curve_SegmentNum-Min_curve_interv)
                            id=Curve_SegmentNum-Min_curve_interv;
                        end
                        P_midpoint = Curve_List(id,:);
                        P2 = Curve_List(id-Min_curve_interv,:);
                        P3 = Curve_List(id+Min_curve_interv,:);
                        corr=[P_midpoint;P2;P3];
                        Result=Func_GetCircleParaFromThreePoints(corr);
                        if(Result.radius~=0)
                            TangentTemp=[-P_midpoint(2)+Result.corr_y P_midpoint(1)-Result.corr_x];
                            CurveTangent(cont_i,:)=[TangentTemp/(eps+norm(TangentTemp)) 0];
                            TempAngles(cont_i)=atan2d(TangentTemp(2),TangentTemp(1));
                        else
                            TangentTemp=[P2(1)-P_midpoint(1) P2(2)-P_midpoint(2)];
                            CurveTangent(cont_i,:)=[TangentTemp/(eps+norm(TangentTemp)) 0];
                            TempAngles(cont_i)=atan2d(TangentTemp(2),TangentTemp(1));
                        end
                    end
                    for i=1:Curve_SegmentNum-1
                        while(abs(TempAngles(i+1)-TempAngles(i))>90)
                            CurveTangent(i+1,:)=-CurveTangent(i+1,:);
                            if(TempAngles(i+1)-TempAngles(i)<=0)
                                TempAngles(i+1)=TempAngles(i+1)+180;
                            else
                                TempAngles(i+1)=TempAngles(i+1)-180;
                            end
                        end
                    end               
                    
                    inc=1;
                    ThetaInDegrees=zeros(sum(1:Maximum_Step),1);
                    for step_i=1:Maximum_Step
                        for step_k=1:Maximum_Step-step_i  
                            u=CurveTangent(step_i,:); 
                            v=CurveTangent(step_i+step_k,:);
                            ThetaInDegrees(inc)=atan2d(norm(cross(u,v)),dot(u,v));
                            inc=inc+1;
                        end 
                    end
                    if(Config.Debug==1)
                        figure(10)
                        f_ax=subplot(2,2,2);
                        histogram(ThetaInDegrees,'Normalization','probability')
                        xlim(f_ax,[0 180]);
                        xlabel('\Theta (degree)')
                        title(['Normalized histogram of measured angles, chain length ranging from ', num2str(1*conversionfactor*1E6,'%10.1f\n'),' to ', num2str(Maximum_Step*conversionfactor*1E6,'%10.1f\n'),' um']);
                    end
                    
                    if(Config.Debug==1)
                        figure(10)
                        subplot(2,2,1)
                        imshow(0.5*flip(imrotate(image_debug,90),1));hold on;
                        intv=25;
                        sample_quiver=(rem(1:1:size(Curve_List,1),intv)==0);
                        q = quiver(Curve_List(sample_quiver,1),Curve_List(sample_quiver,2),CurveTangent(sample_quiver,1),CurveTangent(sample_quiver,2));
                        q.Color = 'green';
                        q.LineWidth = 1;
                        q.AutoScaleFactor=0.3;
                        hold off;
                        title('Binary skeleton image and tangent of the curve (green arrow)');
                        
                    end
                    
                    CosTheta=cos(ThetaInDegrees*pi/180);   
                    loc=max(Min_curve_interv,find(MaxR==max(MaxR),1));
                    Cos_range=round(CurveContourLength(end)); 
                    Cos_list=1:length_interval:Cos_range;
                    meanCosTheta=zeros(size(Cos_list));
                    inc_k=1;
                    for k = Cos_list
                        % Get Indicies 
                        ind = abs(l_length-length_interval*(k-1))<=length_interval;
                        % calculate Mean within radian:
                        meanCosTheta(inc_k) = mean(CosTheta(ind));
                        inc_k=inc_k+1;
                    end    
                    NonNaNloc=~isnan(meanCosTheta);
                    NonNaNloc=and(NonNaNloc,Cos_list<loc);
                    Cos_list_fit=Cos_list(NonNaNloc)'*conversionfactor*1E6;
                    meanCosTheta_fit=meanCosTheta(NonNaNloc)';
                    
                    fitEqn2='b*exp(-x/(a))';
                    f2 = fit(Cos_list_fit,meanCosTheta_fit,fitEqn2);
                    f2.a=f2.a/s_value;
                    if(Config.Debug==1) 
                        figure(10)
                        subplot(2,2,4)
                        plot(Cos_list*conversionfactor*1E6,meanCosTheta,'.k');hold on;
                        plot(f2,Cos_list_fit,meanCosTheta_fit);hold off;
                        xlabel('Chain length(um)');
                        ylabel('<Cos\theta> ');
                        legend('Averaged data','Averaged data selected','Curve fitting');
                        title(['Estimated persistence length: ',num2str(f2.a,'%10.2f\n'),' um'])
                    end 
                end

               if(Config.PersModel_cos==1)
                    Results.Est_PersistanceLength_Cos(blob_i) = f2.a;
               end
               if(Config.PersModel_mse2e==1)
                    Results.Est_PersistanceLength_R2(blob_i) = f1.a;
               end
                Results.maximum_angle(blob_i) = max(ThetaInDegrees(:)); 
                Results.CurveLength_parameter(blob_i) = CurveContourLength(end)*conversionfactor;
                Results.E2ELength_parameter(blob_i) = sqrt((Curve_List(1,1)-Curve_List(end,1)).^2+(Curve_List(1,2)-Curve_List(end,2)).^2)*conversionfactor;
                %Results.Area(blob_i) = Regional_BW(blob_i).Area*conversionfactor;
            end
        end