function [PartitionResults,EdgeMatrix]=FUNC_LEVELSET_shapeCL(ImageFeature,Mask,Config)
ImageFeature = double(ImageFeature);
%% 
Threshold=Config.Threshold;
Iteration=Config.Iteration;
GradientKernelSize=Config.GradientKernelSize;
inerThresh=round(Config.Iteration/1.2)+1;
MaximumBranchArea=Config.BranchSize;

G1=Config.Kernel;
[Gx,Gy] = gradient(G1);   


grdX=imfilter(ImageFeature,Gx,'replicate');
grdY=imfilter(ImageFeature,Gy,'replicate');

[grdHeight,grdWidth]=size(grdX);
GradientSimilarityMapX=zeros([grdHeight grdWidth]+[2*GradientKernelSize 2*GradientKernelSize]);
GradientSimilarityMapY=zeros([grdHeight grdWidth]+[2*GradientKernelSize 2*GradientKernelSize]);
for i=1:2*GradientKernelSize+1
    for j=1:2*GradientKernelSize+1
        GradientSimilarityMapX(i:i+grdHeight-1,j:j+grdWidth-1)=GradientSimilarityMapX(i:i+grdHeight-1,j:j+grdWidth-1)+grdX;
        GradientSimilarityMapY(i:i+grdHeight-1,j:j+grdWidth-1)=GradientSimilarityMapY(i:i+grdHeight-1,j:j+grdWidth-1)+grdY;
    end
end
GradientSimilarityMapX=abs(GradientSimilarityMapX(GradientKernelSize+1:end-GradientKernelSize,GradientKernelSize+1:end-GradientKernelSize));
GradientSimilarityMapY=abs(GradientSimilarityMapY(GradientKernelSize+1:end-GradientKernelSize,GradientKernelSize+1:end-GradientKernelSize));
GradientSimilarityMap1=GradientSimilarityMapX.^2+GradientSimilarityMapY.^2;
GradientSimilarityMap1=GradientSimilarityMap1/...
                       (max(GradientSimilarityMap1(:))-min(GradientSimilarityMap1(:)));
EdgeDetector=1./(1+GradientSimilarityMap1.^Config.Gstrength);
EdgeMatrix=2*(EdgeDetector-0.5);

%%
Mask=bwmorph(Mask,'dilate');
InitialPartitionMask=Mask;
InitialPartition=2*double(Mask)-1;

PreviouspartitionError=0;
for n = 1:Iteration
    BMask=InitialPartition<0;
    OMask=not(BMask);
    LargeOMask=bwmorph(OMask,'dilate',3);
    EdgeMask=xor(OMask,LargeOMask);
    
    IFvalues=ImageFeature(OMask);
    IBvalues=ImageFeature(EdgeMask);
    ifhf=fitdist(IFvalues,'normal');
    FeatureForegroundValue=ifhf.mu;
    ibhf=fitdist(IBvalues,'normal');
    FeatureBackgroundValue=ibhf.mu;
   
    FeatureDirection = ImageFeature - ((FeatureForegroundValue + FeatureBackgroundValue)/2+Config.Istrength*abs(FeatureForegroundValue - FeatureBackgroundValue));
    FeatureDirection=2*double(FeatureDirection>0)-1;
    
    [ux, uy] = gradient(InitialPartition);    
    Contour=2*double(sqrt(ux.^2 + uy.^2)>0);
    InitialPartitionCheck = InitialPartition+ EdgeMatrix.*Contour.*FeatureDirection;
    
    InitialPartitionCheck = imfilter(InitialPartitionCheck,G1, 'replicate','same'); % Noise reduction
    MaskCheckSt1=InitialPartitionCheck>0;
    % Find branch points
    CheckSplitPointsBranch=(InitialPartitionMask-MaskCheckSt1);
    BWBranch=getJoiningPointS(CheckSplitPointsBranch,InitialPartitionMask);
   
    BWBranchMap=getAreaMap(BWBranch);
    BWBranch1=and(BWBranchMap>0,BWBranchMap<MaximumBranchArea);
    % stop mask from splitting
    InitialPartitionMask=or(BWBranch1,MaskCheckSt1);

    InitialPartitionMask=bwmorph(InitialPartitionMask,'clean');
    
    CurrentPartitionError=sum(InitialPartitionMask(:));
    TotalErrorDifference(n)=abs(CurrentPartitionError-PreviouspartitionError);
    if (abs(CurrentPartitionError-PreviouspartitionError)<10 && TotalErrorDifference(n)==TotalErrorDifference(n-1))
        InitialPartition = InitialPartitionMask+InitialPartitionMask-1;break;
    end
    if (n>inerThresh)
        TotalErrorSTDDifference(n-inerThresh)=std(TotalErrorDifference(n-inerThresh:n));
        if(n>inerThresh+1 && TotalErrorSTDDifference(n-inerThresh)-TotalErrorSTDDifference(n-inerThresh-1)<=Threshold)
            InitialPartition = InitialPartitionMask+InitialPartitionMask-1;break;
        end
    end
    PreviouspartitionError=CurrentPartitionError;
    
    InitialPartition = InitialPartitionMask+InitialPartitionMask-1;
%      figure(2)
%      imshow(InitialPartitionMask)
%      pause(0.1)

end
PartitionResults=InitialPartition;
end
