function [PartitionResults,EdgeMatrix,localThreshold]=FUNC_LocalMinimumVaraiceLevelset(Image_input,ThreshMap,Seed_mask,BG_mask,BG_weight,LevelsetConfig)
Image_input = double(Image_input);
[distribution_prop,Weight]=getImageintensityhist_DistributionProp(Image_input,Seed_mask,LevelsetConfig.KernelSize);
localThreshold=(distribution_prop{1}.mu+distribution_prop{2}.mu)/2;
%% 
Iteration=LevelsetConfig.Iteration;
GradientKernelSize=LevelsetConfig.GradientKernelSize;
MaximumBranchArea=LevelsetConfig.MaxMergeSize;

% Edge(image gradient)
MeanGradientMapALL=getImageMeanGradient(Image_input,LevelsetConfig.Kernel,GradientKernelSize);
EdgeDetector=1./(1+MeanGradientMapALL.^LevelsetConfig.Gstrength);
EdgeMatrix=2*(EdgeDetector-0.5);

%% Init parameters
InitialPartition=2*double(Seed_mask)-1;
PreviousPartitionSum=0;

% Boost 
InitialPartitionBoost=or((ThreshMap.*EdgeMatrix-BG_weight*BG_mask)>0.1,Seed_mask);
BoostCheck=bwconncomp(InitialPartitionBoost);
linearInd=find(InitialPartition==1);
BW_Seed=zeros(size(InitialPartitionBoost));
break_all=0;
for ObjCandidate_i=1:length(linearInd)
    for Blob_i=1:length(BoostCheck.PixelIdxList)
        if(sum(BoostCheck.PixelIdxList{Blob_i}==linearInd(ObjCandidate_i))>0)
            BW_Seed(BoostCheck.PixelIdxList{Blob_i}) = 1;
            BoostCheck.PixelIdxList{Blob_i}=[];
            BoostCheck.PixelIdxList=BoostCheck.PixelIdxList(~cellfun(@isempty,BoostCheck.PixelIdxList));
            break_all=1;
            
            % Merge Check
            CheckMergePointsBranch=(BW_Seed-Seed_mask)>0;
            BWBranchMergeMap=getAreaMap(CheckMergePointsBranch);
            BWBranchMergeFix=and(BWBranchMergeMap<MaximumBranchArea,BWBranchMergeMap>0);
            BWPartition=or(Seed_mask,BWBranchMergeFix);
            BWPartition=bwmorph(BWPartition,'clean');
            InitialPartition=2*double(BWPartition)-1;
            break;
        end
    end
    if(break_all==1)
        break;
    end
end

for n = 1:Iteration
    FeatureBackgroundValue=distribution_prop{1}.mu;
    FeatureObjectValue=distribution_prop{2}.mu; 

    [InitialPartitionMask,localThreshold]=LevelsetBranchCheck_Evolve(Image_input,...
        InitialPartition,...
        EdgeMatrix,...
        BG_mask,...
        BG_weight,...
        FeatureObjectValue,FeatureBackgroundValue,...
        LevelsetConfig);
    
    %figure(5);subplot(2,1,1);imshow(InitialPartition);subplot(2,1,2);imshow(InitialPartitionMask);
    % Stop condition
    CurrentPartitionSum=sum(InitialPartitionMask(:));
    if(CurrentPartitionSum==0)
        InitialPartition=2*double(Seed_mask)-1;
        break;
    end 
    
    TotalErrorDifference(n)=abs(CurrentPartitionSum-PreviousPartitionSum);
    if (n>1 && abs(CurrentPartitionSum-PreviousPartitionSum)<2 && TotalErrorDifference(n)==TotalErrorDifference(n-1))
        % 
        CheckVarianceDifference=zeros(1,3);
        distribution_prop=getImageintensityhist_DistributionProp(Image_input,InitialPartitionMask,LevelsetConfig.KernelSize);
        CheckVarianceDifference(1)=(Weight(1)*distribution_prop{1}.sigma.^2+Weight(2)*distribution_prop{2}.sigma.^2);
        check_step=0.1*[1 -1];
        for i_c=1:2
            LevelsetConfig.Istrength=check_step(i_c);
            [InitialPartitionCheck,localThreshold]=LevelsetBranchCheck_Evolve(Image_input,...
            InitialPartition,...
            EdgeMatrix,...
            BG_mask,...
            BG_weight,...
            FeatureObjectValue,FeatureBackgroundValue,...
            LevelsetConfig);
            [distribution_propcheck,Weight]=getImageintensityhist_DistributionProp(Image_input,InitialPartitionCheck,LevelsetConfig.KernelSize);
            CheckVarianceDifference(i_c+1)=(Weight(1)*distribution_propcheck{1}.sigma.^2+Weight(2)*distribution_propcheck{2}.sigma.^2);
            if(CheckVarianceDifference(1)>CheckVarianceDifference(2))
                InitialPartitionMask=InitialPartitionCheck;
            end
        end
        LevelsetConfig.Istrength=0;
        if(CheckVarianceDifference(1)>CheckVarianceDifference(3))
            if(CheckVarianceDifference(3)<CheckVarianceDifference(2))
                InitialPartitionMask=InitialPartitionCheck;
            end
        else
            InitialPartition = InitialPartitionMask+InitialPartitionMask-1;break;
        end
    end

    % Updates
    PreviousPartitionSum=CurrentPartitionSum;
    InitialPartition = 2*double(InitialPartitionMask)-1;
    [distribution_prop,Weight]=getImageintensityhist_DistributionProp(Image_input,InitialPartitionMask,LevelsetConfig.KernelSize);

end
PartitionResults=InitialPartition>0;
end
