function BW_out=FindmaximumlengthBW(BW,Weight)
% Find the longest connected blobs in the image
% input image must be the skeleton of the object.
[BW_Height,BW_Width]=size(BW);
PotentialStartingPoint=bwmorph(BW,'endpoints');
%
Connections=imfilter(uint8(BW),[1 1 1;1 1 1;1 1 1],'same');
BW_BranchPoints=(Connections>=4).*BW;

BW_BranchBlobs=bwconncomp(BW_BranchPoints);
Branch_num=BW_BranchBlobs.NumObjects;
if(Branch_num==0)
    BW_out=BW;
    return;
end

if(isempty(Weight))
    Weight=zeros(BW_Height,BW_Width);
end
% Number of line segment
SkeletonMaskSegment=(double(BW)-double(BW_BranchPoints))>0;
Regional_BW=regionprops(SkeletonMaskSegment,'Area','PixelList','PixelIdxList');
Node_num=length(Regional_BW);

% find end points in each segment
EndpointsPoints=bwmorph(SkeletonMaskSegment,'endpoints');
[EndpointX,EndpointY]=ind2sub([BW_Height,BW_Width],find(1==EndpointsPoints));

% figure(3)
% imshow(BW);

Node=struct('Label',num2cell(1:Node_num),'Endpoints',-ones(2,2),'BranchNum',0,'BranchLabel',zeros(1,2),'Area',0,'PixelList',[],'NeighbourList',[],'DeletedList',[]);
for i_regionblob=1:Node_num
    Node(i_regionblob).Label=i_regionblob;
    Node(i_regionblob).Area=Regional_BW(i_regionblob).Area*(1+sum(Weight(Regional_BW(i_regionblob).PixelIdxList))); % Set weight
    Node(i_regionblob).PixelList=Regional_BW(i_regionblob).PixelList;
    % Node Endpoints
    Ep_inc=1;
    k_hit_id=0;
    for j_pixellist=1:size(Regional_BW(i_regionblob).PixelList,1)
        Ep_hit=0;
        for k=1:length(EndpointX)
            if(EndpointX(k)==Regional_BW(i_regionblob).PixelList(j_pixellist,2) && EndpointY(k)==Regional_BW(i_regionblob).PixelList(j_pixellist,1))
                Node(i_regionblob).Endpoints(Ep_inc,:)=[EndpointX(k),EndpointY(k)];
                k_hit_id=k;
                Ep_hit=1;
                break;
            end
        end
        if(Ep_hit==1)
            EndpointX(k_hit_id)=[];
            EndpointY(k_hit_id)=[];
            Ep_inc=Ep_inc+1;
            if(isempty(EndpointX))
               Node(i_regionblob).Endpoints(Ep_inc,:)=Node(i_regionblob).Endpoints(Ep_inc-1,:);
               break; 
            end
        end
    end 
    Node(i_regionblob).BranchNum=Ep_inc-1;
    % Node Neightbour
    for j_branchNum=1:Branch_num
        [testX,testY]=ind2sub([BW_Height,BW_Width],BW_BranchBlobs.PixelIdxList{j_branchNum});
        for i=1:length(testX)
            if(abs(Node(i_regionblob).Endpoints(1,1)-testX(i))<=1 && abs(Node(i_regionblob).Endpoints(1,2)-testY(i))<=1)
                if(Node(i_regionblob).BranchLabel(1)==0)
                    Node(i_regionblob).BranchLabel(1)=j_branchNum;
                else
                    Node(i_regionblob).BranchLabel(2)=j_branchNum; % single point
                end
                break;
            end
             if(abs(Node(i_regionblob).Endpoints(2,1)-testX(i))<=1 && abs(Node(i_regionblob).Endpoints(2,2)-testY(i))<=1)
                Node(i_regionblob).BranchLabel(2)=j_branchNum;
                break;
            end
        end
    end
    if(Node(i_regionblob).BranchLabel(1)==0 && Node(i_regionblob).BranchLabel(2)==0)
        Node(i_regionblob).BranchLabel(2)=[];
        Node(i_regionblob).BranchLabel(1)=[];
    elseif Node(i_regionblob).BranchLabel(1)==0 && Node(i_regionblob).BranchLabel(2)~=0
        Node(i_regionblob).BranchLabel(1)=Node(i_regionblob).BranchLabel(2);
        Node(i_regionblob).BranchLabel(2)=[];
    elseif Node(i_regionblob).BranchLabel(1)~=0 && Node(i_regionblob).BranchLabel(2)==0
        Node(i_regionblob).BranchLabel(2)=[];
    end
end

% Create NeighbourList
for i_regionblob=1:Node_num
    neighbour_inc=1;
    for j_regionblob=1:Node_num
        if(i_regionblob~=j_regionblob)
            LabelstoFind=length(Node(i_regionblob).BranchLabel);
            checkSum=0;
            for i_find=1:LabelstoFind
                checkSum=checkSum+sum(Node(i_regionblob).BranchLabel(i_find)==Node(j_regionblob).BranchLabel(:));
            end
            if(checkSum>0)
                Node(i_regionblob).NeighbourList(neighbour_inc)=j_regionblob;
                neighbour_inc=neighbour_inc+1;
            end
        end
    end
end

%% ·㷨
[StartingPointX,StartingPointY]=ind2sub([BW_Height,BW_Width],find(PotentialStartingPoint>0));
max_value=0;
max_value_list=[];
for i_start=1:length(StartingPointX)
    %%%%
    % Find starting Node
    Starting_node=0;
    for i_node=1:Node_num
        if(Node(i_node).Endpoints(1,1)==StartingPointX(i_start) && ...
           Node(i_node).Endpoints(1,2)==StartingPointY(i_start))
            Starting_node=i_node;
            continue;
        end
        if(Node(i_node).BranchNum>1)
            if(Node(i_node).Endpoints(2,1)==StartingPointX(i_start) && ...
               Node(i_node).Endpoints(2,2)==StartingPointY(i_start))
                Starting_node=i_node;
                continue;
            end
        end
    end
    if(Starting_node==0)
       continue;
    end
    % Ѱ·
    NodeTest=Node;
    node_list=Starting_node;
    completed_nodelist=[];
    while(~isempty(node_list))
        node_list_temp=[];
        node_list_inc=1;
        check_all=length(node_list);
        for i_checknode=1:check_all
            %
            N_S=node_list(i_checknode);
            %ͬһڵ
            neightbourNum=length(NodeTest(N_S).NeighbourList);
            if(neightbourNum==0)
                completed_nodelist=[completed_nodelist N_S];
            end
            ConnectNeighbourList=[];
            for i_n=1:neightbourNum
                N_C=NodeTest(N_S).NeighbourList(i_n);
                node_list_temp(node_list_inc)=N_C;
                node_list_inc=node_list_inc+1;
                % ϲȨ
                if(length(NodeTest(N_C).Label)~=1)
                    if(NodeTest(N_C).Area<Node(N_C).Area+NodeTest(N_S).Area)
                        NodeTest(N_C).Label=[Node(N_C).Label NodeTest(N_S).Label];
                        NodeTest(N_C).Area=Node(N_C).Area+NodeTest(N_S).Area;
                    end
                else
                    NodeTest(N_C).Area=NodeTest(N_C).Area+NodeTest(N_S).Area;
                    NodeTest(N_C).Label=[NodeTest(N_C).Label NodeTest(N_S).Label];
                end
                % ɾڵ
                NodeTest(N_C).NeighbourList=NodeTest(N_C).NeighbourList(NodeTest(N_C).NeighbourList(:)~=N_S);
                % ¼connectNeighbourList
                ConnectNeighbourList=[ConnectNeighbourList N_C];
                %%%%
            end
            %ɾڵ
            for i_nc=1:length(ConnectNeighbourList)
                N_DeleteSource=ConnectNeighbourList(i_nc);
                DeleteNeighbourList=ConnectNeighbourList(ConnectNeighbourList~=N_DeleteSource);
                for i_delete=1:length(DeleteNeighbourList)
                    NodeTest(N_DeleteSource).NeighbourList=NodeTest(N_DeleteSource).NeighbourList(NodeTest(N_DeleteSource).NeighbourList~=DeleteNeighbourList(i_delete));
                end
            end
        end
        % Ψһ
        node_list_temp=unique(node_list_temp(:));
        % node list
        node_list=node_list_temp;
    end 
    for i_comp=1:length(completed_nodelist)
        n_comp=completed_nodelist(i_comp);
        if(NodeTest(n_comp).Area>max_value)
            max_value=NodeTest(n_comp).Area;
            max_value_list=NodeTest(n_comp).Label;
        end
    end
end
BW_out=zeros([BW_Height,BW_Width]);
chainlistNum=length(max_value_list);
for i_drawBW=1:chainlistNum
    inds=sub2ind([BW_Height,BW_Width],Node(max_value_list(i_drawBW)).PixelList(:,2),Node(max_value_list(i_drawBW)).PixelList(:,1));
    BW_out(inds)=1;
    % Method 1:Find endpoints and create shortest path to replace branch point
    if(i_drawBW<chainlistNum)
        PN1=Node(max_value_list(i_drawBW)).Endpoints;
        if(PN1(2,1)==-1)
            PN1(2,:)=PN1(1,:);
        end
        PN2=Node(max_value_list(i_drawBW+1)).Endpoints;
        if(PN2(2,1)==-1)
            PN2(2,:)=PN2(1,:);
        end
        xymap = [PN1(1,:) PN2(1,:);
                 PN1(2,:) PN2(1,:);
                 PN1(1,:) PN2(2,:);
                 PN1(2,:) PN2(2,:);];
        CheckMindistlist=[norm(PN1(1,:)-PN2(1,:));
                          norm(PN1(2,:)-PN2(1,:));
                          norm(PN1(1,:)-PN2(2,:));
                          norm(PN1(2,:)-PN2(2,:));];
        CheckMindistId=find(CheckMindistlist==min(CheckMindistlist(:)),1); % return only 1
        ShortpathROI=[min(xymap(CheckMindistId,1),xymap(CheckMindistId,3))
             min(xymap(CheckMindistId,2),xymap(CheckMindistId,4))
             max(xymap(CheckMindistId,1),xymap(CheckMindistId,3))
             max(xymap(CheckMindistId,2),xymap(CheckMindistId,4))
             ];
        ShortpathImage=zeros(ShortpathROI(3)-ShortpathROI(1)+1,ShortpathROI(4)-ShortpathROI(2)+1);
        ShortpathImage2=ShortpathImage;
        Pconn1=sub2ind(size(ShortpathImage),...
                       xymap(CheckMindistId,1)-ShortpathROI(1)+1,...
                       xymap(CheckMindistId,2)-ShortpathROI(2)+1);
        Pconn2=sub2ind(size(ShortpathImage),...
                       xymap(CheckMindistId,3)-ShortpathROI(1)+1,...
                       xymap(CheckMindistId,4)-ShortpathROI(2)+1);
        ShortpathImage(Pconn1)=1;
        ShortpathImage2(Pconn2)=1;
        D1 = bwdist(ShortpathImage, 'quasi-euclidean');
        D2 = bwdist(ShortpathImage2, 'quasi-euclidean');
        D_sum = D1 + D2;
        D_sum = round(D_sum*32)/32;
        path_pixels = imregionalmin(D_sum);
        [ROIx,ROIy]=find(path_pixels==1);
        OriginalCorrx=ShortpathROI(1)+ROIx-1;
        OriginalCorry=ShortpathROI(2)+ROIy-1;
        inds_branch=sub2ind([BW_Height,BW_Width],OriginalCorrx,OriginalCorry);
        BW_out(inds_branch)=1;
    end
end
BW_out=bwmorph(BW_out,'thin');
BW_out=bwmorph(BW_out,'spur');
