function [ImagePartitionOutput,Sgnfuncbw,localThreshold]=LevelsetBranchCheck_Evolve(Image_input,ImagePartition,edgeMatrix,BG_mask,BG_weight,FeatureForegroundValue,FeatureBackgroundValue,Config)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  localThreshold=((FeatureForegroundValue + FeatureBackgroundValue)/2);
  Sgnfuncbw = Image_input - localThreshold-Config.Istrength*abs(FeatureForegroundValue - FeatureBackgroundValue);
  Sgnfunc=2*double(Sgnfuncbw>0)-1;  
  
  InitPartitionMap=ImagePartition>0;
  Contour=xor(bwmorph(InitPartitionMap,'dilate'),bwmorph(InitPartitionMap,'erode'));
  ImagePartitionEvolve = ImagePartition+ edgeMatrix.*Contour.*Sgnfunc-BG_mask*BG_weight;

  % Noise reduction
  ImagePartitionEvolve = imfilter(ImagePartitionEvolve,Config.Kernel, 'replicate','same'); 
  EvolvedPartitionMap=ImagePartitionEvolve>0;
  
  % Check Split
  BgMask=Sgnfuncbw<0;
  CheckSplitPointsBranch=(InitPartitionMap-EvolvedPartitionMap)>0;
  if(sum(CheckSplitPointsBranch(:))~=0)
      % Condition 1
    BWBranchSplitEvolve=getAreaMap(EvolvedPartitionMap);
    AreaInit=getAreaMap(InitPartitionMap);
    MaximumSize=max(AreaInit(:));
      % Condition 2 (remove large segmentation error)           
    NegEvolveMap=getAreaMap(and(InitPartitionMap,BgMask));
    
    SplitObjects=NegEvolveMap>min(Config.MinSplitSize,Config.MaxSplitRatio*MaximumSize);
    CheckSplitPointsBranch=(CheckSplitPointsBranch-SplitObjects)>0;
    
    SplitObjects2m=getConnectingBranchMask(CheckSplitPointsBranch,BWBranchSplitEvolve,Config.MinSplitSize);
    ImagePartitionOutput=or(EvolvedPartitionMap,SplitObjects2m); 

%      figure(45)
%      subplot(2,1,1)
%      imshow(ImagePartitionOutput)
%      subplot(2,1,2)
%      imshow(InitPartitionMap)
  else
    ImagePartitionOutput=EvolvedPartitionMap;
  end
  
  % Check Merge
  CheckMergeBranch=(EvolvedPartitionMap-InitPartitionMap)>0;
  if(sum(CheckSplitPointsBranch(:))~=0)
      BWBranchMergeMap=getAreaMap(CheckMergeBranch);
      BWBranchMergeFix=and(BWBranchMergeMap<Config.MaxMergeSize,BWBranchMergeMap>0);
      ImagePartitionOutput=or(ImagePartitionOutput,BWBranchMergeFix);
  end
  ImagePartitionOutput=bwmorph(ImagePartitionOutput,'clean');