function ResultMap=getConnectingBranchMask(branchPointsMask,objectMaskArea,MaxBlobSize)
Spacing=sqrt(2);
[MsizeX,MsizeY]=size(objectMaskArea);
CCheckpoints=bwconncomp(branchPointsMask);
AreaInd=find(objectMaskArea>0);
[ObjX,ObjY]=ind2sub([MsizeX MsizeY],AreaInd);

ResultMap=zeros(MsizeX,MsizeY);
if(~isempty(CCheckpoints) || ~isempty(ObjX))
    for i=1:CCheckpoints.NumObjects
        unique_blobsize=[];
        valid=0;
        [testX,testY]=ind2sub([MsizeX MsizeY],CCheckpoints.PixelIdxList{i});
        for j=1:length(testX)
            testDistIDs=sqrt((ObjX-testX(j)).^2+(ObjY-testY(j)).^2)<=Spacing;
            testDistSum=sum(testDistIDs(:));
            if(testDistSum>0)
                calculatedInd=sub2ind([MsizeX MsizeY],ObjX(testDistIDs),ObjY(testDistIDs));
                unique_blobsize=unique([objectMaskArea(calculatedInd)' unique_blobsize]);
                if(length(unique_blobsize)>1)
                    valid=1;
                    continue; 
                else
                    if(unique_blobsize(1)<MaxBlobSize)
                        valid=1;
                        continue;
                    end
                end
            end
        end
        if(valid==1)
           ResultMap(CCheckpoints.PixelIdxList{i})=1; 
        end
    end
end