function MeanGradientMapALL=getImageMeanGradient(Image_input,Kernel,GradientKernelSize)
[Gx,Gy] = gradient(Kernel);   
grdX=imfilter(Image_input,Gx,'replicate');
grdY=imfilter(Image_input,Gy,'replicate');

[grdHeight,grdWidth]=size(Image_input);
MeanGradientMapX=zeros([grdHeight grdWidth]+[2*GradientKernelSize 2*GradientKernelSize]);
MeanGradientMapY=zeros([grdHeight grdWidth]+[2*GradientKernelSize 2*GradientKernelSize]);
for i=1:2*GradientKernelSize+1
    for j=1:2*GradientKernelSize+1
        MeanGradientMapX(i:i+grdHeight-1,j:j+grdWidth-1)=MeanGradientMapX(i:i+grdHeight-1,j:j+grdWidth-1)+grdX;
        MeanGradientMapY(i:i+grdHeight-1,j:j+grdWidth-1)=MeanGradientMapY(i:i+grdHeight-1,j:j+grdWidth-1)+grdY;
    end
end
MeanGradientMapX=abs(MeanGradientMapX(GradientKernelSize+1:end-GradientKernelSize,GradientKernelSize+1:end-GradientKernelSize));
MeanGradientMapY=abs(MeanGradientMapY(GradientKernelSize+1:end-GradientKernelSize,GradientKernelSize+1:end-GradientKernelSize));
MeanGradientMapALL=sqrt(MeanGradientMapX.^2+MeanGradientMapY.^2);
MeanGradientMapALL=MeanGradientMapALL/...
                       (max(MeanGradientMapALL(:))-min(MeanGradientMapALL(:)));